#ifndef BEM_H_
#define BEM_H_

#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <malloc.h>
#include <math.h>
#include "type.h"

using namespace std;
#define GAUSSTOTAL 140
#define INTETIMES 100
#define FITTIMES 15		//for fit CURVE from points

class LinEle{
  public:
		 double xs,xe,ys,ye;   //vertexes of a linear element
		 int us,qs,ue,qe;      //variables of this element
		 //gausspoint for line element
		 double *gp1,*gp2,*gp3,*gp4,*gp5,*gp6,*gp7,*gp8,*gp12,*gp16,*gp20,*gp24,*gp32;
};

typedef union {
	       LinEle *le;
	       }ElementUnion;

class Element {
  public:
		EleType type;
		ElementUnion ele;
		};
		
class Edge{
  public:
		 int edgeno;		//global no. of this edge
		 EdgeType edgetype;  //Line Arcedge or Curve
		 ElecType electype;  //force edge or natural edge or border
		 Flag stype,etype;   //if need to add additional Sourcepoint
		 		//2 : it's a BORDER, need a addition sp here
		 		//1	not BORDER  , also need
		 int medium;         //medium it belongs to
			     //for BORDER,it's the meidum it "should" belong
			     //if it isn't eauql to current medium no.
			     //it must be a BORDER appeared secondly.
		 int reversemed;     //for border,this is it's other medium
			     //for BORDER appeared secondly, 
			     //it is the medium it actually belongs to
		 Edge *reverseedge;    //reverse side of a BORDER
		 int condno;         //for force edge:conductor it belongs to
		 int portno;         //for force edge:cond object it belongs to
		         	//different conds from one object have a same port no.
		 struct Vert *s,*e;         //Start point and end point
		 int sno,eno;        //edge==edge->s->edge[sno]
	 			//if this edge is a line, don't set Line structure
	 			//set element in edge directly
		 LinEle *ele;         //linear elements on this edge
		 double l,dx,dy;      //length of every element
		 int elenum;          //total elements on this edge
		 double minx,miny,maxx,maxy;  
				     //scope of this edge,if it is a line
		 double A,B,C;       //coefficient of equation Ax+By+C=0
		 };

class Conductor {
  public:
		 char name[15];		 //for output
		 int mediumno;       //the medium it belongs to
		 int condno;         //no. of this conductor
		 int portno;         //no of cond object it belongs to before SC
		 int edgenum;        //total edges of this conductor
		 Edge **edge;        //edge pointer array of it
		 double minx,miny,maxx,maxy;		//like Shell & Object
		 double close;
		 };

class Medium {
  public:
		 char name[15];		 //for output
		 int mediumno;       //no. of this medium
		 int edgenum;        //total edges of it
		 double diel;        //dielectric constant or rho
		 Edge **edge;        //edge pointer array
		 Bool *edgevalidity; //if this edge is valid
		 int validedgenum;   //current valid edge number of medium
		 int condnum;        //total conductor of it
		 Conductor **cond;   //conductors pointer array
		 int *varnum;
		 int *varstart;
		 int vartotal,spstart,spend;
		 };

class Vert{
  public:
		 double x,y;
		 int edgenum;        //total edges relative to this vert
		 int forcenum;       //     force edges
		 int bordernum;      //     borders
		 int varnum;         //     variables
		 Edge **edge;        //edges' pointer array
		 Element *feedback;
		 int Uvarno;
		 int *Qvarno;
		 };

class SourcePoint {
  public:
		 double x,y;//location of sp
		 int no;    //no. in all sourcepoints
		 int u1,u2; //relative volt variable
			    //u2 is valid when it is an additional sourcepoint
		};

#endif
