#ifndef _GLOBALVAR_H_
#define _GLOBALVAR_H_
 
#include <iostream>
#include <fstream>
#include "type.h"
#include "shape.h"
#include "bem.h"

using namespace std;
//zcs.r2d.y
extern  Shell **shell;
extern  Object **obj;
extern 	int xnum, ynum;
extern 	unsigned short errline;
extern 	const BYTE TOKENLEN;	//sizeof(ReservedWordsList)/sizeof(ReservedWordsList[0]);
extern 	char **constvarlist;
extern 	double *constvaluelist;
extern 	Bool constflag;
extern 	Flag errflg;
extern 	Bool touchflag;
extern 	Bool rhoflag;
extern 	Bool dielflag;
extern 	int shlno, objno;
extern 	char curname[15];
extern 	double tmp1, tmp2;
extern 	Flag *calcarray;
extern 	int *toucharray;
extern 	Object *curobj, *lastobj;
extern 	Shell *curshl;
extern 	Box *curbox;
extern 	Poly *curpoly;
extern 	Points *curpoints;
extern 	int smgno;
extern 	int yylex();
extern 	void initialKeyword();
extern 	Bool isalpha(char);
extern 	Bool isdigit(char);
extern 	int doalpha(ifstream *);
extern 	int dodigit(ifstream *);
extern 	void yyerror(const char *s);
//zcs.2d.c
extern 	char *errmsg;
extern 	unsigned long errlocate;
extern 	ifstream *tpddlin;
extern 	int *shapenum;
extern 	unsigned int _edgeCount;
extern 	Bool autoflag;
extern 	Bool divflag;
extern 	Bool voltflag;
extern 	Bool gaussflag;
extern 	Bool blockflag;
extern 	Bool capaflag;
extern 	Bool fileflag;
extern 	Bool induflag;
extern 	Bool layerflag;
extern 	Bool resiflag;
extern 	double static_res;
extern 	int realeles;
//zcs.shapecalc.c
extern 	double maxx, maxy, minx, miny;
extern 	ShellRelation **shellrela;
extern 	ShellRelation *shlrelfield;
extern 	ShellRelation **objectrela;
extern 	ShellRelation *objrelfield;
extern 	Object **condobj;
extern 	Object **medobj;
extern 	char **nametable;
extern 	int medobjnum;				//number of medium object
extern 	int condobjnum;				//number of conductor object
extern 	double *volt;
extern 	int edgeno;					//Global No. of edge, just a unique No., not a actual num
extern 	Edge **edge, **forceedge, **naturaledge, **borderedge;
extern 	Vert **vert;
extern 	int vertnum, edgenum, forceedgenum, naturaledgenum, borderedgenum;
extern 	int verttotal, edgetotal, forceedgetotal, naturaledgetotal, borderedgetotal;
extern 	int vertrealloc, edgerealloc, forcerealloc, naturalrealloc, borderrealloc;
extern 	Conductor *cond;			//Conductor fit to BEM requirements
extern 	Medium *med;				//Medium which includes conductors and edges
extern 	int condnum;				//Length of conds
extern 	int condno;					//Current conductor number
extern 	int mednum;					//Length of med
//zcs.bem.c
extern 	Bool batchflag;
extern 	int gbvarno;
extern 	int spno;
extern 	double g00[GAUSSTOTAL], gic[GAUSSTOTAL], fa11[GAUSSTOTAL], fa12[GAUSSTOTAL];
extern 	double ct, dt, mw, ms;
#endif
