#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
#include "2d.h"
#include "shape.h"
#include "globalvar.h"

using namespace std;

extern int yyparse ( void );
extern int *countshape ( char * );
extern void shapecalculation();
extern void bem();

int main ( int argc, char **argv )
{
	char *str;
	int i, j;

	if ( argc < 2 ) {
		printf ( "/****************************************\n" );
		printf ( "* B2D -- 2D Resistance Extaractor     *\n" );
		printf ( "*     using boundary element method     *\n" );
		printf ( "*    Copyright Tsinghua Univ.(2014)     *\n" );
		printf ( "*          All rights reserved.         *\n" );
		printf ( "****************************************/\n" );
		//printf ( "Usage: %s [-a] [-g]<filename>\n", argv[0] );
		printf ( "Usage: %s [-a] <filename>\n", argv[0] );
		printf ( "The option:\n" );
		printf ( "    -a/A		use auto divide.\n" );
		//printf ( "    -g/G		use gauss solve.\n" );
		exit ( 0 );
	}

	i = 1;
	while ( i < argc - 1 ) {  //in case argc>=3
		str = argv[i];
		if ( str[0] != '-' ) {
			printf ( "Usage: %s [-a] [-g] <filename>\n", argv[0] );
			printf ( "The option:\n" );
			printf ( "    -a/A		use auto divide.\n" );
			//printf ( "    -g/G		use gauss solve.\n" );
			exit ( 0 );
		}
		if ( strlen( str ) != 2 ) {
				printf ( "\nUnknown option. Type %s for help please\n", argv[0] );
				exit(0);
		}
		else {

			for ( j = 1; j < strlen ( str ); j++ ) 
				if ( ( str[j] == 'a' ) || ( str[j] == 'A' ) )
					autoflag = TRUE;
				//else if((str[j]=='g')||(str[j]=='G'))
					//gaussflag=TRUE;
				else{
					printf ( "\nUnknown option. Type %s for help please\n", argv[0] );
					exit(0);
				}
		}
		i++;
	}

	str = argv[argc - 1];    //yuwj debuged.
	return Res2d ( str );
}

double Res2d ( const char *fileName)
{
	//_edgeCount=1800;  //yuwj. from 1000 to 4000
	char curfile[1024];	    //yuwj. from 1024 to 4024
	strcpy ( curfile, fileName );	//The last parameter is the input file
	generalprocess ( curfile );
	return static_res;
}

void generalprocess ( char *f)
{
	shapenum = countshape ( f );
	ifstream tpddlin1 ( f );
	if ( tpddlin1 == NULL )
		printf ( "File open error !\n" );
	tpddlin = &tpddlin1;
	//printf("Handling %s\n",f);
	yyparse();	//goto y.tab.c
	shapecalculation();
	bem();
	tpddlin->close();
}
