#include "shape.h"
#include "bem.h"
#include "globalvar.h"

void freespace()
{
	int i, j, k;
	Edge *ed = NULL;

	free ( ( char * ) calcarray );
	for ( i = 0; i < condobjnum; i++ ){
		free ( ( char * ) nametable[i] );
		free ( ( double * ) volt );
	}

	free ( ( char * ) nametable );
	for ( i = 0; i < vertnum; i++ ) {
		free ( ( char * ) vert[i / 10][i % 10].Qvarno );
		free ( ( char * ) vert[i / 10][i % 10].edge );
		free ( ( char * ) vert[i / 10][i % 10].feedback );
	}
	for ( k = 0; k <= vertrealloc; k++ )
		free ( ( char * ) vert[k] );
	free ( ( char * ) vert );

	for ( k = 0; k <= edgerealloc; k++ )
		free ( ( char * ) edge[k] );
	free ( ( char * ) edge );

	for ( k = 0; k <= forcerealloc; k++ )
		free ( ( char * ) forceedge[k] );
	free ( ( char * ) forceedge );

	for ( k = 0; k <= naturalrealloc; k++ )
		free ( ( char * ) naturaledge[k] );
	free ( ( char * ) naturaledge );

	for ( k = 0; k <= borderrealloc; k++ )
		free ( ( char * ) borderedge[k] );
	free ( ( char * ) borderedge );

	for ( i = 0; i < condnum; i++ )
		free ( ( char * ) cond[i].edge );
	free ( ( char * ) cond );

	for ( i = 0; i < mednum; i++ ) {
		for ( k = 0; k < med[i].edgenum; k++ ) {
			ed = med[i].edge[k];
			if ( ed->ele != NULL ) {
				for ( j = 0; j < ed->elenum; j++ ) {
					if ( ed->ele[j].gp1 != NULL )
						free ( ( char * ) ed->ele[j].gp1 );
					if ( ed->ele[j].gp2 != NULL )
						free ( ( char * ) ed->ele[j].gp2 );
					if ( ed->ele[j].gp3 != NULL )
						free ( ( char * ) ed->ele[j].gp3 );
					if ( ed->ele[j].gp4 != NULL )
						free ( ( char * ) ed->ele[j].gp4 );
					if ( ed->ele[j].gp5 != NULL )
						free ( ( char * ) ed->ele[j].gp5 );
					if ( ed->ele[j].gp6 != NULL )
						free ( ( char * ) ed->ele[j].gp6 );
					if ( ed->ele[j].gp7 != NULL )
						free ( ( char * ) ed->ele[j].gp7 );
					if ( ed->ele[j].gp8 != NULL )
						free ( ( char * ) ed->ele[j].gp8 );
					if ( ed->ele[j].gp12 != NULL )
						free ( ( char * ) ed->ele[j].gp12 );
					if ( ed->ele[j].gp16 != NULL )
						free ( ( char * ) ed->ele[j].gp16 );
					if ( ed->ele[j].gp20 != NULL )
						free ( ( char * ) ed->ele[j].gp20 );
					if ( ed->ele[j].gp24 != NULL )
						free ( ( char * ) ed->ele[j].gp24 );
					if ( ed->ele[j].gp32 != NULL )
						free ( ( char * ) ed->ele[j].gp32 );
				}
				free ( ( char * ) ed->ele );
				ed->ele = NULL;		//Otherwise BORDER will be freed twice
			}
		}
		free ( ( char * ) med[i].edge );
		free ( ( char * ) med[i].cond );
	}
	free ( ( char * ) med );
	free ( ( char * ) toucharray );

}
