#include <cstring>
#include <cmath>
#include <cstdlib>
#include <cstdio>
#include "shape.h"
#include "globalvar.h"
//Print the result to the standard output with conductors' name
//      Rij=Vji/Ii
void out ( double **r )
{
	int maxlen = 0;
	int i, j,k;
	double Res=0.0;
	for ( i = 0; i < condobjnum; i++ )
		if ( strlen ( nametable[i] ) > maxlen )
			maxlen = strlen ( nametable[i] );
	double resmax = 0;
	int res_scal;
	double res_mul;
	if ( resiflag ) {
		for ( i = 0; i < condobjnum; i++ )
			if ( ( condobjnum < 10 || i == 0 ) && calcarray[i] == 1 )
				for ( j = 0; j < condobjnum; j++ ) {
					if ( resmax < 1 / fabs ( r[i][j] ) )
						resmax = 1 / fabs ( r[i][j] );
				}
		res_scal = int ( floor ( log ( resmax ) / log ( 10 ) ) );
#ifdef BUILD_BIN
		printf ( "\nresmax= %f, res_scal=%d\n", resmax, res_scal );
		printf ( "R:Omega (1e%d)\n", res_scal );
#endif
		res_mul = exp10 ( res_scal );
		//res_mul = exp ( res_scal );	//yuwj commented. Apr. 4, 2014
	}
#ifdef BUILD_BIN
	for ( i = 0; i <= maxlen; i++ )
	  //printf(" ");
		for ( i = 0; i < condobjnum; i++ )
		  //printf("%11s",nametable[i]);
		  //printf("\n");
			for ( i = 0; i < condobjnum; i++ )
				if ( calcarray[i] == 1 )
					for ( j = 0; j < i; j++ ) {
						if ( calcarray[j] == 1 && j != i ) {
							r[i][j] = ( r[i][j] + r[j][i] ) / 2;
							r[j][i] = r[i][j];
						}
					}
	//for symmetric matrix, by yuwj
	for ( i = 0; i < condobjnum; i++ )
		if ( ( condobjnum < 10 || i == 0 ) && calcarray[i] == 1 ) {
			for ( j = strlen ( nametable[i] ); j < maxlen; j++ )
				printf ( " " );
			printf ( "%s:", nametable[i] );
			for ( j = 0; j < condobjnum; j++ )
				printf ( "%11.6f", -1 / r[i][j] / res_mul );    //yuwj
			//printf("%10.6",1/fabs(r[i][j])/res_mul);
			printf ( "\n" );
		}
#endif
	//zcs.Print the results
	if(voltflag==TRUE){
			Res=0.0;
		for(i=0;i<condobjnum;i++){
			k=0.0;
			for(j=0;j<condobjnum;j++){
				if (condobj[i]->voltval>condobj[j]->voltval){
			    	Res=Res+1/(-1/r[i][j]);
					k++;
				}
			}
			if(k>=2)
			  printf("parall_res=%lf.\n",1/Res);
			else if (k>0){
			  for(j=0;j<condobjnum;j++){
				  if(condobj[i]->voltval>condobj[j]->voltval){
					  static_res=-1/r[i][j];
					  printf("res=%lf.\n",static_res);
				  }
			  }
			}
		}
				//zcs.20140226.printf("res = %lf.\n",1/Res);
	}
	else{
		for(i=1;i<condobjnum;i++){
			for(j=0;j<i;j++){
				static_res=-1/r[i][j];
				printf("res = %lf.\n",static_res);
			}
		}
	}

	for ( i = 0; i < condobjnum; i++ )
		free ( ( char * ) r[i] );
	free ( ( char * ) r );
}
