%{
#include "globalvar.h"
#include "type.h"
#include "shape.h"
#include "bem.h"
#include <sys/times.h>
#include <iostream>
#include <fstream>

using namespace std;

int i,j;
double an;
static char **ReservedWordsList= NULL;
static BYTE constvarnum;

%}
%start program
%union {
      double dval;
      int ival;
      Point pval;
      Ang aval;
}

%token ang        300
%token ang1       301
%token ang2       302
%token arc        303
%token at         304
%token autoyacc   305
%token begin      306
%token block      307
%token box        308
%token capa       309
%token circ       310
%token copy       311
%token cut        312
%token diel       313
%token elements   314
%token end        315
%token from       316
%token h          317
%token in         318
%token indu       319
%token layer      320
%token line       321
%token move       322
%token para       323
%token points     324
%token poly       325
%token r          326
%token resi       327
%token rho        328
%token right      329
%token to         330
%token touch      331
%token up         332
%token volt       333
%token w          334
%token window     335
%token with       336

%token  NEWCONSTVAR       400
%token  OLDCONSTVAR       401

%token <ival> NEWOBJ    500
%token <ival> OLDOBJ    501

%token <dval> FREG      601

%type  <ival>  NEWCONSTVAR
%type  <ival>  OLDCONSTVAR

%type  <ival> OBJ
%type  <dval> EXPRESS
%type  <dval> FACTOR
%type  <aval> ANGDEF
%type  <aval> ANGMDEF
%type  <aval> ANG2DEF
%type  <aval> ANG1DEF
%type  <pval> POINT
%left '+' '-'
%left '*' '/'
%left UMINUS


%%
program:SEGMENTS
;
SEGMENTS:
|SEGMENTS SEGMENT
;
SEGMENT:BEGIN LINES END
;
BEGIN:begin
{
  //printf("Total shape:%d\n",shapenum[smgno[);    by yuwj
  smgno= 0;
  curobj=lastobj=NULL;
  curshl=NULL;
  curbox=NULL;
  curpoly=NULL;
  curpoints=NULL;
  errline=0;
  constvarnum=0;
  shlno=objno=0;
  shell=NULL;
  obj=NULL;
  calcarray=NULL;
  toucharray=NULL;
  constflag=FALSE;
  touchflag=FALSE;
  dielflag=FALSE;
  rhoflag=FALSE;
  shell=(Shell **)malloc(shapenum[smgno]*sizeof(Shell *));
  obj=(Object **)malloc(shapenum[smgno]*sizeof(Object *));
  toucharray=(int *)malloc(shapenum[smgno]*sizeof(int));
  for(j=0;j<shapenum[smgno];j++)
    toucharray[j]=j;
  
  constvarlist =new char*[2*shapenum[smgno]];// (2*shapenum[smgno]*sizeof(char *));
  for(i=0;i<2*shapenum[smgno];i++)
    constvarlist[i]= new char[15];//(char *)malloc(15*sizeof(char ));
  constvaluelist= new double[2*shapenum[smgno]];//(double *)malloc(2*shapenum[smgno]*sizeof(double));
  
  if(smgno!=0)		//more than one segment
    induflag=capaflag=resiflag=layerflag=blockflag=FALSE;
}
;

LINES:
| LINES LINE
;
END:end
{
  for(i=0;i<objno;i++)
  {
    curobj=obj[i];
    curshl=curobj->shell[0];
    curobj->maxx=curshl->maxx;
    curobj->maxy=curshl->maxy;
    curobj->minx=curshl->minx;
    curobj->miny=curshl->miny;
    for(j=1;j<curobj->shellnum;j++)
    {
      curshl=curobj->shell[j];
      if(curshl->maxx>curobj->maxx)
        curobj->maxx=curshl->maxx;
      if(curshl->maxy>curobj->maxy)
        curobj->maxy=curshl->maxy;
      if(curshl->minx<curobj->minx)
        curobj->minx=curshl->minx;
      if(curshl->miny<curobj->miny)
        curobj->miny=curshl->miny;
    }
	}
  
  if(dielflag)
    if(resiflag)
      yyerror("need to calculate residance but described 'diel'\n\n");
  if(rhoflag)
    if(capaflag)
      yyerror("need to calculate capacitance but described 'rho'\n\n");
  if(dielflag && rhoflag)
    yyerror("described 'diel' and 'rho' at the same time\n\n");
  if(!dielflag && !rhoflag)
    yyerror("no 'diel' and 'rho' described\n\n");
  
  if(!capaflag && !resiflag && !induflag)
  {
  	//printf("Warning!!!!!Nothing to calculate\n");
    if(dielflag)
      capaflag=TRUE;
    if(rhoflag)
      resiflag=TRUE;
    calcarray=(Flag *)malloc(objno*sizeof(Flag));
    for(i=0;i<objno;i++)
      calcarray[i]=1;
  }
  
  if(blockflag)
    layerflag=FALSE;
  if(layerflag)
    blockflag=FALSE;
  //if(errflg==0)
  //  printf("Compiled successful!!!\n");
  //free((char *)constvaluelist);
  delete []constvaluelist;
  constvaluelist= NULL;

  for(i=0;i<2*shapenum[smgno];i++)
    delete[] (constvarlist[i]);
  //free((char *)constvarlist);
  delete[] (constvarlist);
  constvarlist= NULL;
  if(errflg!=0)
    exit(0);
  //times(&time2);
  //shapecalculation();  /*main BEM calcualtion, by yuwj */
  //times(&time1);
  //long tck=sysconf(_SC_CLK_TCK);  //by yuwj
  //printf("shape calculation time:%.2f (seconds)\n",(time1.tms_utime-time2.tms_utime)/(double)tck);
  //bem();
  //freespace();
  smgno++;
}
;

LINE:PARADEF
    |BOXDEF
    |ARCDEF
    |CIRCDEF
    |POLYDEF
    |POINTSDEF
    |COPYDEF
    |INDEF
    |WINDOWDEF
    |CAPADEF
    |RESIDEF
    |INDUDEF
    |LINEDEF
    |CUTDEF
    |TOUCHDEF
    |AUTODEF
    |BLOCKDEF
    |LAYERDEF
    ;
PARADEF: para CONSTDEF CONSTDEFS
;
AUTODEF: autoyacc
{
  autoflag=TRUE;
}
;
CONSTDEFS:
| CONSTDEFS ';' CONSTDEF
;
CONSTDEF:NEWCONSTVAR '=' EXPRESS
{
  constvaluelist[$1]=$3;
}
;
EXPRESS:FACTOR
  {  $$=$1;  }
| EXPRESS '+' EXPRESS
  {  $$=$1+$3;  }
| EXPRESS '-' EXPRESS
  {
    $$=$1-$3;
  }
;
FACTOR:FREG
{
  $$=$1;
}
|OLDCONSTVAR
{
  $$=constvaluelist[$1];
}
|'(' EXPRESS ')'
{
  $$=$2;
}
|FACTOR '*' FACTOR
{
  $$=$1*$3;
}
|FACTOR '/' FACTOR
{
  $$=$1/$3;
}
|'-' FACTOR %prec UMINUS
{
  $$=-$2;
}
;
BOXDEF:BOXNAMEDEF ELECDEF BOXGEODEF BOXELEMDEF
{
  setboxshell(curshl,curbox);
  //printobj(curobj);
}

BOXNAMEDEF:box OBJ ';'
{
  if($2<0)    //new object
  {
    curobj=(Object *)malloc(sizeof(Object));
    initobj(curobj);            //shape.c
    strcpy(curobj->name,curname);
    curobj->shell=(Shell **)malloc(sizeof(Shell *));
    obj[-$2-1]=curobj;
    curobj->objno=-$2-1;
  }
  else
  {
    curobj=obj[$2];
    curobj->shell=(Shell **)realloc((char *)curobj->shell,(curobj->shellnum+1)*sizeof(Shell *));
  }
  curshl=(Shell *)malloc(sizeof(Shell));
  curshl->obj=obj[curobj->objno];
  curshl->shellno=shlno;
  shell[shlno++]=curshl;
  curshl->shapetype=BOX;
  curobj->shell[curobj->shellnum]=curshl;
  curbox=(Box *)malloc(sizeof(Box));
  curshl->shape.bbox=curbox;
  curobj->shellnum++;
}
;	     
BOXGEODEF:at '(' POINT ')' ';' ANGDEF w '=' EXPRESS ';' h '=' EXPRESS
{
  
  if($6.deflt)
    $6.an=0.0;
  curbox->width=$9;
  curbox->height=$13;
  curbox->x1=$3.x;
  curbox->y1=$3.y;
  curbox->x2=$3.x+$9*cos($6.an);
  curbox->y2=$3.y+$9*sin($6.an);
  curbox->x3=curbox->x2-$13*sin($6.an);
  curbox->y3=curbox->y2+$13*cos($6.an);
  curbox->x4=$3.x-$13*sin($6.an);
  curbox->y4=$3.y+$13*cos($6.an);
  
}
| at '(' POINT ')' ';' right '(' POINT ')' ';' up '(' POINT ')'
{
  curbox->width=sqrt(($8.x-$3.x)*($8.x-$3.x)+($8.y-$3.y)*($8.y-$3.y));
  curbox->height=sqrt(($13.x-$3.x)*($13.x-$3.x)+($13.y-$3.y)*($13.y-$3.y));
  curbox->x1=$3.x;
  curbox->y1=$3.y;
  curbox->x2=$8.x;
  curbox->y2=$8.y;
  curbox->x3=$13.x+$8.x-$3.x;
  curbox->y3=$13.y+$8.y-$3.y;
  curbox->x4=$13.x;
  curbox->y4=$13.y;
}
;

OBJ:NEWOBJ
{
  $$=-$1-1;
}
| OLDOBJ
{
  $$=$1;
}
;
ELECDEF:
| volt ';'
{
  if(curobj->electype==NONE)
    curobj->electype=CONDUCTOR;
  else if(curobj->electype==MEDIUM)
    yyerror("Electype not match for a same obj\n");
}
|volt '=' EXPRESS ';'
{
  if(curobj->electype==NONE)
  {
    curobj->electype=CONDUCTOR;
    curobj->voltval=$3;
  }
  else if(curobj->electype==MEDIUM)
    yyerror("Electype not match for a same obj\n");
  else if(curobj->voltval==INVALIDVOLT)
    curobj->voltval=$3;
  else if(curobj->voltval!=$3)
    yyerror("Different volt definition for a same conductor\n");
  voltflag=TRUE;
}
|diel ';'
{
  dielflag=TRUE;
  if(curobj->electype==NONE)
    curobj->electype=MEDIUM;
  else if(curobj->electype==CONDUCTOR)
    yyerror("Electype not match for a same obj\n");
}
|diel '=' EXPRESS ';'
{
  dielflag=TRUE;
  if(curobj->electype==NONE)
  {
    curobj->electype=MEDIUM;
    curobj->dielval=$3;
  }
  else if(curobj->electype==CONDUCTOR)
    yyerror("Electype not match for a same obj\n");
  else if(curobj->dielval==INVALIDDIEL)
    curobj->dielval=$3;
  else if(curobj->dielval!=$3)
    yyerror("Different diel value for a same medium\n");
}
|rho ';'
{
  rhoflag=TRUE;
  if(curobj->electype==NONE)
    curobj->electype=MEDIUM;
  else if(curobj->electype==CONDUCTOR)
    yyerror("Electype not match for a same obj\n");
}
|rho '=' EXPRESS ';'
{
  rhoflag=TRUE;
  if(curobj->electype==NONE)
  {
    curobj->electype=MEDIUM;
    curobj->rhoval=$3;
             }
  else if(curobj->electype==CONDUCTOR)
    yyerror("Electype not match for a same obj\n");
  else if(curobj->rhoval==INVALIDDIEL)
    curobj->rhoval=$3;
  else if(curobj->rhoval!=$3)
    yyerror("Different diel value for a same meiudm\n");
}
;
POINT:EXPRESS ',' EXPRESS
{
  $$.x=$1;
  $$.y=$3;
}
;
ANGDEF:
{
  $$.deflt=1;
}
|ang '=' EXPRESS
{
  $$.an=$3*PIE/180;
	$$.deflt=0;
}
|ang '=' EXPRESS ';'
{
  $$.an=$3*PIE/180;
  $$.deflt=0;
}
;
ANGMDEF:
{
	$$.deflt=1;
}
|';'
{
  $$.deflt=1;
}
|';' ang '=' EXPRESS
{
	$$.an=$4*PIE/180;
	$$.deflt=0;
}
;
ANG1DEF:
{
	$$.deflt=1;
}
| ang1 '=' EXPRESS
{
  $$.an=$3*PIE/180;
	$$.deflt=0;
}
| ang1 '=' EXPRESS ';'
{
  $$.an=$3*PIE/180;
	$$.deflt=0;
}
;
ANG2DEF:
{
	$$.deflt=1;
}
|ang2 '=' EXPRESS
{
  $$.an=$3*PIE/180;
	$$.deflt=0;
}
|ang2 '=' EXPRESS ';'
{
  $$.an=$3*PIE/180;
	$$.deflt=0;
}
;
BOXELEMDEF:
{
  curbox->elesonwidth=ELES_ON_EDGE;
  curbox->elesonheight=ELES_ON_EDGE;
  autoflag=FALSE;  //yuwj added
}
|';' elements '=' EXPRESS
{
  curbox->elesonwidth=(int)$4;
  curbox->elesonheight=(int)$4;
  autoflag= FALSE;  //yuwj added
}
|';' elements '=' EXPRESS ',' EXPRESS
{
  curbox->elesonwidth=(int)$4;
  curbox->elesonheight=(int)$6;
  autoflag= FALSE;  //yuwj added
}
|elements '=' EXPRESS
{
  curbox->elesonwidth=(int)$3;
  curbox->elesonheight=(int)$3;
  autoflag= FALSE;   //yuwj added
}
|elements '=' EXPRESS ',' EXPRESS
{
  curbox->elesonwidth=(int)$3;
  curbox->elesonheight=(int)$5;
  autoflag= FALSE;   //yuwj added
}
;
ARCDEF:ARCNAMEDEF ELECDEF ARCGEODEF ARCELEMDEF
{
	//printobj(curobj);
}
;
ARCNAMEDEF:arc OBJ ';'
{
  
}
;
ARCGEODEF:at '(' POINT ')' ';' r '=' EXPRESS ';' ANG1DEF ANG2DEF
{

}
;
ARCELEMDEF:
{
  
}
;
CIRCDEF:CIRCNAMEDEF ELECDEF CIRCGEODEF CIRCELEMDEF
{
	//printobj(curobj);
}
;
CIRCNAMEDEF:circ OBJ ';'
{
  
}
;
CIRCGEODEF:at '(' POINT ')' ';' r '=' EXPRESS ';' ANG1DEF ANG2DEF
{
  
}
;
CIRCELEMDEF:
{
  
}
;
POLYDEF:POLYNAMEDEF ELECDEF POLYGEODEF POLYELEMDEF
{
  setpolyshell(curshl,curpoly);
  //printobj(curobj);
}
POLYNAMEDEF:poly OBJ ';'
{
  if($2<0)
  {
    curobj=(Object *)malloc(sizeof(Object));
		 initobj(curobj);            //shape.c
		 strcpy(curobj->name,curname);
		 curobj->shell=(Shell **)malloc(sizeof(Shell *));
		 obj[-$2-1]=curobj;
		 curobj->objno=-$2-1;
  }
  else {
    curobj=obj[$2];
    curobj->shell=(Shell **)realloc((char *)curobj->shell,(curobj->shellnum+1)*sizeof(Shell *));
  }
  curshl=(Shell *)malloc(sizeof(Shell));
  curshl->obj=obj[curobj->objno];
  curshl->shellno=shlno;
  shell[shlno++]=curshl;
  curshl->shapetype=POLY;
  curobj->shell[curobj->shellnum]=curshl;
  curpoly=(Poly *)malloc(sizeof(Poly));
  curshl->shape.ppoly=curpoly;
  curobj->shellnum++;
  curpoly->vertnum=0;
  curpoly->vertex=NULL;
  curpoly->eles=NULL;
}
;
POLYGEODEF:POLYPARTSDEF
{
  if(curpoly->vertnum<2)
    yyerror("A poly must includes more than 2 vertexes\n");
  curpoly->eles=(int *)malloc((curpoly->vertnum-1)*sizeof(int));
  i=0;
}
;
POLYPARTSDEF:'(' POINT ')'
{
  curpoly->vertex=(Point *)malloc(3*sizeof(Point));
  curpoly->vertex[0]=$2;
  curpoly->vertnum++;
}
|POLYPARTSDEF ',' '(' POINT ')'
{
  if(curpoly->vertnum>=3)
    curpoly->vertex=(Point *)realloc((char *)curpoly->vertex,(curpoly->vertnum+1)*sizeof(Point));
  curpoly->vertex[curpoly->vertnum]=$4;
  curpoly->vertnum++;
}
;
POLYELEMDEF:
{
  for(i=0;i<curpoly->vertnum-1;i++)
    curpoly->eles[i]=ELES_ON_EDGE;
  //autoflag=FALSE;  //yuwj added
}
|';' elements '=' POLYDIVIDEF
{
  for(j=i;j<curpoly->vertnum-1;j++)
	       curpoly->eles[j]=curpoly->eles[i-1];
  realeles++;
  divflag=TRUE;  //yuwj added
}
;
POLYDIVIDEF:EXPRESS
{
  if(i<curpoly->vertnum-1)
    curpoly->eles[i++]=(int)$1;
  else yyerror("Division number more than line number\n");
  //autoflag=FALSE;  //yuwj added
}
|POLYDIVIDEF ',' EXPRESS
{
	if(i<curpoly->vertnum-1)
    curpoly->eles[i++]=(int)$3;
  else yyerror("Division number more than line number\n");
  //autoflag=FALSE;  //yuwj added
}
;
POINTSDEF:POINTSNAMEDEF ELECDEF POINTSGEODEF POINTSARCDEF POINTSELEMDEF
{
	//printobj(curobj);
}
;
POINTSNAMEDEF:points OBJ ';'
{
  
}
;
POINTSGEODEF:POINTARRAYDEF
{
           
}
;
POINTARRAYDEF:'(' POINT ')'
{
  
}
;
POINTSELEMDEF:
{
  
}
             ;
POINTSARCDEF:';' EXPRESS ',' EXPRESS
{
  
}
;
POINTSDIVIDEF:EXPRESS
{
  
}
;
LINEDEF:line OBJ ';' ELECDEF from '(' POINT ')' to '(' POINT ')' LINEELEMDEF
{
}
;
LINEELEMDEF:
{
}
|';' elements '=' EXPRESS
{
}
;
COPYDEF:COPYNAMEDEF COPYELECDEF MOVEDEF ELEMDEF
{
}
;
COPYELECDEF:ELECDEF
{
	     
}
;
COPYNAMEDEF:copy OBJ from OBJ ';' 
{
	    
}
;
MOVEDEF:move '(' POINT ')' ANGMDEF
{
	if($5.deflt)               //ang is defaulted 
	  an=0.0;
  else an=$5.an;
	if(lastobj->shellnum>1 && !Equal(an,0.0))
	  printf("We cannot rotate a complex object with several shapes\nYou should just move it\n");
  for(i=0;i<lastobj->shellnum;i++)
  {
    if(curobj->shell==NULL)
      curobj->shell=(Shell **)malloc(sizeof(Shell *));
	  else
      curobj->shell=(Shell **)realloc((char *)curobj->shell,(curobj->shellnum+1)*sizeof(Shell *));
    curshl=(Shell *)malloc(sizeof(Shell));
    curshl->obj=obj[curobj->objno];
    curshl->shellno=shlno;
    shell[shlno++]=curshl;
    curobj->shell[curobj->shellnum]=curshl;
    curobj->shellnum++;
    curshl->shapetype=lastobj->shell[i]->shapetype;
    switch(curshl->shapetype) {
	  case BOX:    
      curbox=(Box *)malloc(sizeof(Box));
      curshl->shape.bbox=curbox;
      *curbox=*lastobj->shell[i]->shape.bbox;
      curbox->x1=curbox->x1+$3.x;
      curbox->y1=curbox->y1+$3.y;
      curbox->x2=curbox->x1+curbox->width*cos(an);
      curbox->y2=curbox->y1+curbox->width*sin(an);
      curbox->x3=curbox->x2-curbox->height*sin(an);
      curbox->y3=curbox->y2+curbox->height*cos(an);
      curbox->x4=curbox->x1-curbox->height*sin(an);
      curbox->y4=curbox->y1+curbox->height*cos(an);
      setboxshell(curshl,curbox);
      break;
	  case POLY:   
      if(!Equal(an,0.0))
			  printf("We donot support rotation of polygon!\n");
      curpoly=(Poly *)malloc(sizeof(Poly));
      curshl->shape.ppoly=curpoly;
      copypoly(lastobj->shell[i]->shape.ppoly,curpoly);
      for(j=0;j<curpoly->vertnum;j++)
      {
				curpoly->vertex[j].x+=$3.x;
				curpoly->vertex[j].y+=$3.y;
      }
      setpolyshell(curshl,curpoly);
      break;
    }          //switch
	}
	i=0;           //for element division
}
;
ELEMDEF: 
|';' elements '=' DIVIDEF
|elements '=' DIVIDEF
;
DIVIDEF:EXPRESS
{
	switch(curshl->shapetype) {
  case BOX    :curbox->elesonwidth=(int)$1;   break;
  case POLY   :curpoly->eles[i]=(int)$1;      break;
  }
	i++;
}
|DIVIDEF ',' EXPRESS
{
	switch(curshl->shapetype) {
  case BOX    :
    if(i==1)
      curbox->elesonheight=(int)$3;
    else printf("Too many division numbers for a box\n");
    break;
  case POLY   :curpoly->eles[i]=(int)$3;      break;
  }
	i++;
}
;
CUTDEF:cut OBJ with OBJ
{
}
;
TOUCHDEF:TOUCHOBJDEF TOUCHOBJS
{
}
;
TOUCHOBJDEF:touch OBJ
{
  i=$2;
  touchflag=1;
  if(i<0)
    yyerror("Undefined object in touch command!\n");
  else if(obj[i]->electype!=CONDUCTOR)
    yyerror("Only conductoe can be touched\n") ;
}
;
TOUCHOBJS:
{
  yyerror("Only one object couldnot be touched!\n");
}
|',' OBJ
{
  if($2<0)
    yyerror("Undefined object in touch command!\n");
  else 
    if(obj[$2]->electype!=CONDUCTOR)
      yyerror("Only conductors can be touched\n");
    else toucharray[$2]=toucharray[i];
}
|',' TOUCHOBJS ',' OBJ
{
  if($4<0)
    yyerror("Undefined object in touch command!\n");
  else if(obj[$4]->electype!=CONDUCTOR)
    yyerror("Only conductors can be touched\n");
  else toucharray[$4]=toucharray[i];
}
;
CALCOBJS:CALCOBJS ',' OBJ
{
  if($3<0)
    yyerror("Undefined object in capa command!\n");
  calcarray[$3]=1;
}
|OBJ
{
  calcarray=(Flag *)malloc(objno*sizeof(Flag));
  if($1<0)
    yyerror("Undefined object in capa command!\n");
  for(i=0;i<objno;i++)
    calcarray[i]=0;
  calcarray[$1]=1;
}
;
CAPADEF:capa
{
  if(!resiflag)
  {
    capaflag=TRUE;
    resiflag=FALSE;
  }
  calcarray=(Flag *)malloc(objno*sizeof(Flag));
  for(i=0;i<objno;i++)
    calcarray[i]=1;
}
|capa CALCOBJS
{
  if(!resiflag)
  {
    capaflag=TRUE;
    resiflag=FALSE;
  }
}
;
INDUDEF:indu
{
  if(!resiflag)
  {
    induflag=TRUE;
    resiflag=FALSE;
  }
	calcarray=(Flag *)malloc(objno*sizeof(Flag));
  for(i=0;i<objno;i++)
    calcarray[i]=1;
}
|indu CALCOBJS
{
  if(!resiflag)
  {
    induflag=TRUE;
    resiflag=FALSE;
  }
}
;
INDEF:OBJ in OBJ
{
  if($1<0 || $3<0)
    yyerror("Undefined object in IN command\n");
	else if(obj[$1]->electype!=MEDIUM ||obj[$3]->electype!=MEDIUM)
	  yyerror("object in IN command is not a medium\n");
  else {
  }
}
;

WINDOWDEF:window from '(' POINT ')' to '(' POINT ')'
RESIDEF:resi
{
  if(!capaflag && !induflag)
  {
    resiflag=TRUE;
    capaflag=FALSE;
    induflag=FALSE;
  }
  calcarray=(Flag *)malloc(objno*sizeof(Flag));
  for(i=0;i<objno;i++)
    calcarray[i]=1;
}
|resi CALCOBJS
{
  if(!capaflag && !induflag)
  {
    capaflag=FALSE;
    induflag=FALSE;
    resiflag=TRUE;
  }
}
;

LAYERDEF:layer
{
  if(!blockflag)
  {
    layerflag=TRUE;
    blockflag=FALSE;
  }
  ynum=-1;
}
|layer EXPRESS
{
  if(!blockflag)
  {
    layerflag=TRUE;
    blockflag=FALSE;
  }
  ynum=(int)$2;
}
;

BLOCKDEF:block
{
  if(!layerflag)
  {
    blockflag=TRUE;
    layerflag=FALSE;
  }
  ynum=-1;
  xnum=-1;
}
| block EXPRESS
{
  if(!layerflag)
  {
    blockflag=TRUE;
    layerflag=FALSE;
  }
  xnum=(int)$2;
  ynum=-1;
}
| block EXPRESS EXPRESS
{
  if(!layerflag)
  {
    blockflag=TRUE;
    layerflag=FALSE;
  }
  ynum=(int)$2;
  xnum=(int)$3;
}
;

%%
int yylex()
{
  char ch;
  initialKeyword();
  do{
    ch=tpddlin->get();
    if(ch==EOF)
      return EOF;
    if(ch=='/'){
      char NextChar;
      
      NextChar=tpddlin->get();
      if(NextChar=='/'){
        while(NextChar!='\n')
          NextChar=tpddlin->get();
        ch=tpddlin->get();
      }
      else if(NextChar=='*') {
        char FirstChar;
        
        NextChar=tpddlin->get();
        do {
          FirstChar=NextChar;
          NextChar =tpddlin->get();
        } while(!(FirstChar=='*' && NextChar=='/'));
        ch=tpddlin->get();
      }
      else  tpddlin->putback(NextChar);
    }
    
    if(ch=='\n')
      errline++;
  }while((ch==' ')||(ch=='\n')||(ch=='\t')||(ch=='\r'));
  tpddlin->putback(ch);
  
  if(isalpha(ch))
    return doalpha(tpddlin);
  else
    if(isdigit(ch))
      return dodigit(tpddlin);
    else
      return tpddlin->get();
}

Bool isalpha(char ch)
{
  if((ch>='A')&&(ch<='Z'))
    return TRUE;
  if((ch>='a')&&(ch<='z'))
    return TRUE;
  if  (ch=='_')
    return TRUE;
  
  return FALSE;
}

Bool isdigit(char ch)
{
  if((ch>='0')&&(ch<='9'))
    return TRUE;
  
  return FALSE;
  
}

int doalpha(ifstream *input)
{
  int i,pos;
  
  char str[15],ch;
  
  ch=input->get();
  pos=0;
  while(isalpha(ch)||isdigit(ch)){
    str[pos++]=ch;
    ch=input->get();
  }
  str[pos]=0;
  input->putback(ch);
  
  for(i=0;i<TOKENLEN;i++)
    if(strcmp(str,ReservedWordsList[i])==0)
    {
      yylval.ival=i;
      if(strcmp(str,"para")==0)
      {
        constflag=TRUE;
      }
      else constflag=FALSE;     //Other Keyword,PARA line ended
	  //printf("Reserved ID=%d\n",300+i);
      return 300+i;
    }
  
  for(i=0;i<objno;i++)
    if(strcmp(str,obj[i]->name)==0)
    {
      yylval.ival=i;
      return OLDOBJ;
    }
  
  for(i=0;i<constvarnum;i++)
    if(strcmp(str,constvarlist[i])==0)
    {
      yylval.ival=i;
      return OLDCONSTVAR;
    }
  
  if(constflag){
    strcpy(constvarlist[constvarnum],str);
    yylval.ival=constvarnum++;
    return NEWCONSTVAR;
  }
  else {
    strcpy(curname,str);
    yylval.ival=objno++;
    return NEWOBJ;
  }
}

int dodigit(ifstream *input)
{
  double i;
  *input>>i;
  yylval.dval=i;
  
  return FREG;
}

void yyerror(const char *s)
{
  char ch;
  errflg++;
  
  errmsg=(char *)malloc(strlen(s)+32);
  errlocate=tpddlin->tellg();
  ch=tpddlin->get();
  tpddlin->putback(ch);
  printf("Error the %3dth   Line %d   CharLocate %ld : %s Current char is %c\n",errflg,errline,errlocate,s,ch);
  //sprintf(errmsg,"Line %d : %s",errline,s);
}

void initialKeyword()
{
  if( ReservedWordsList )
    return;
  ReservedWordsList= new char*[37];
  ReservedWordsList[0]= new char[strlen("ang")+1];
  strcpy( ReservedWordsList[0], "ang" );
  ReservedWordsList[1]= new char[strlen("ang1")+1];
  strcpy( ReservedWordsList[1], "ang1" );
  ReservedWordsList[2]= new char[strlen("ang2")+1];
  strcpy( ReservedWordsList[2], "ang2" );
  ReservedWordsList[3]= new char[strlen("arc")+1];
  strcpy( ReservedWordsList[3], "arc" );
  ReservedWordsList[4]= new char[strlen("at")+1];
  strcpy( ReservedWordsList[4], "at" );
  ReservedWordsList[5]= new char[strlen("auto")+1];
  strcpy( ReservedWordsList[5], "auto" );
  ReservedWordsList[6]= new char[strlen("begin")+1];
  strcpy( ReservedWordsList[6], "begin" );
  ReservedWordsList[7]= new char[strlen("block")+1];
  strcpy( ReservedWordsList[7], "block" );
  ReservedWordsList[8]= new char[strlen("box")+1];
  strcpy( ReservedWordsList[8], "box" );
  ReservedWordsList[9]= new char[strlen("capa")+1];
  strcpy( ReservedWordsList[9], "capa" );
  ReservedWordsList[10]= new char[strlen("circ")+1];
  strcpy( ReservedWordsList[10], "circ" );
  ReservedWordsList[11]= new char[strlen("copy")+1];
  strcpy( ReservedWordsList[11], "copy" );
  ReservedWordsList[12]= new char[strlen("cut")+1];
  strcpy( ReservedWordsList[12], "cut" );
  ReservedWordsList[13]= new char[strlen("diel")+1];
  strcpy( ReservedWordsList[13], "diel" );
  ReservedWordsList[14]= new char[strlen("elements")+1];
  strcpy( ReservedWordsList[14], "elements" );
  ReservedWordsList[15]= new char[strlen("end")+1];
  strcpy( ReservedWordsList[15], "end" );
  ReservedWordsList[16]= new char[strlen("from")+1];
  strcpy( ReservedWordsList[16], "from" );
  ReservedWordsList[17]= new char[strlen("h")+1];
  strcpy( ReservedWordsList[17], "h" );
  ReservedWordsList[18]= new char[strlen("in")+1];
  strcpy( ReservedWordsList[18], "in" );
  ReservedWordsList[19]= new char[strlen("indu")+1];
  strcpy( ReservedWordsList[19], "indu" );
  ReservedWordsList[20]= new char[strlen("layer")+1];
  strcpy( ReservedWordsList[20], "layer" );
  ReservedWordsList[21]= new char[strlen("line")+1];
  strcpy( ReservedWordsList[21], "line" );
  ReservedWordsList[22]= new char[strlen("move")+1];
  strcpy( ReservedWordsList[22], "move" );
  ReservedWordsList[23]= new char[strlen("para")+1];
  strcpy( ReservedWordsList[23], "para" );
  ReservedWordsList[24]= new char[strlen("points")+1];
  strcpy( ReservedWordsList[24], "points" );
  ReservedWordsList[25]= new char[strlen("poly")+1];
  strcpy( ReservedWordsList[25], "poly" );
  ReservedWordsList[26]= new char[strlen("r")+1];
  strcpy( ReservedWordsList[26], "r" );
  ReservedWordsList[27]= new char[strlen("resi")+1];
  strcpy( ReservedWordsList[27], "resi" );
  ReservedWordsList[28]= new char[strlen("rho")+1];
  strcpy( ReservedWordsList[28], "rho" );
  ReservedWordsList[29]= new char[strlen("right")+1];
  strcpy( ReservedWordsList[29], "right" );
  ReservedWordsList[30]= new char[strlen("to")+1];
  strcpy( ReservedWordsList[30], "to" );
  ReservedWordsList[31]= new char[strlen("touch")+1];
  strcpy( ReservedWordsList[31], "touch" );
  ReservedWordsList[32]= new char[strlen("up")+1];
  strcpy( ReservedWordsList[32], "up" );
  ReservedWordsList[33]= new char[strlen("volt")+1];
  strcpy( ReservedWordsList[33], "volt" );
  ReservedWordsList[34]= new char[strlen("w")+1];
  strcpy( ReservedWordsList[34], "w" );
  ReservedWordsList[35]= new char[strlen("window")+1];
  strcpy( ReservedWordsList[35], "window" );
  ReservedWordsList[36]= new char[strlen("with")+1];
  strcpy( ReservedWordsList[36], "with" );  
}

