#include <stdlib.h>
#include <assert.h>
#include "shape.h"
#include "bem.h"
#include "globalvar.h"

void shapecalculation()
{
	int i, j, i1, j1, shl1, shl2,realpolynum=0;  //realpolynum:real number of poly in file(except port).
	ShellRelation sr;
	ShapeEdge *se = NULL, *c1 = NULL, *freese, *freese1;
	Poly *freepoly;
	Shell *shl = NULL;
	Bool neednewcond;
	Edge *ed = NULL;
	FILE *fp;
	char ch;
	int master;
	shellrela = NULL;
	shlrelfield = NULL;
	objectrela = NULL;
	objrelfield = NULL;
	condobj = NULL;
	medobj = NULL;
	vert = NULL;
	edge = NULL;
	forceedge = NULL;
	naturaledge = NULL;
	borderedge = NULL;
	med = NULL;
	cond = NULL;

	maxx = obj[0]->maxx;
	minx = obj[0]->minx;
	maxy = obj[0]->maxy;
	miny = obj[0]->miny;
	for ( j = 1; j < objno; j++ ) {
		if ( maxx < obj[j]->maxx )
			maxx = obj[j]->maxx;
		if ( minx > obj[j]->minx )
			minx = obj[j]->minx;
		if ( maxy < obj[j]->maxy )
			maxy = obj[j]->maxy;
		if ( miny > obj[j]->miny )
			miny = obj[j]->miny;
	}

	medobj = ( Object ** ) malloc ( objno * sizeof ( Object * ) );
	condobj = ( Object ** ) malloc ( objno * sizeof ( Object * ) );
	medobjnum = condobjnum = 0;
	volt = ( double * ) malloc ( objno * sizeof ( double ) );
	for ( i = 0; i < objno; i++ ){
		if ( obj[i]->electype == CONDUCTOR ) {
			calcarray[condobjnum] = calcarray[i];
			condobj[condobjnum++] = obj[i];
			if ( obj[i]->voltval == INVALIDVOLT ) {
				//printf("Warning!!!conductor %s has no volt defined!\n",obj[i]->name);
				//comment by yuwj
				obj[i]->voltval = 0.0;
			}
			volt[i]=obj[i]->voltval;
		}
		else if ( obj[i]->electype == MEDIUM ) {
			obj[i]->mediumno = medobjnum;
			medobj[medobjnum++] = obj[i];
			if ( resiflag )
				if ( obj[i]->rhoval == INVALIDRHO ) {
					//printf("Warning!!!medium %s has no rho defined!\n",obj[i]->name);
					obj[i]->rhoval = 1.0;
				}
		}
		else {
			//printf("Warning!!! object %s has no electype!\n",obj[i]->name);
			obj[i]->electype = CONDUCTOR;
			obj[i]->voltval = 0.0;
			calcarray[condobjnum] = calcarray[i];
			condobj[condobjnum++] = obj[i];
			if ( obj[i]->voltval == INVALIDVOLT ) {
			//printf("Warning!!!conductor %s has no volt defined!\n",obj[i]->name);
				obj[i]->voltval = 0.0;
			}
			volt[i]=obj[i]->voltval;
		}
	}

	nametable = ( char ** ) malloc ( condobjnum * sizeof ( char * ) );
	for ( i = 0; i < condobjnum; i++ ) {
		nametable[i] = ( char * ) malloc ( 15 * sizeof ( char ) );
		strcpy ( nametable[i], condobj[i]->name );
	}

	//init relations between different shells
	shellrela =
		( ShellRelation ** ) malloc ( ( shlno - 1 ) * sizeof ( ShellRelation * ) );
	shlrelfield =
		( ShellRelation * ) malloc ( ( shlno * ( shlno - 1 ) / 2 ) *
									 sizeof ( ShellRelation ) );
	for ( i = 0; i < shlno - 1; i++ )
		shellrela[i] = shlrelfield + ( shlno + shlno - 1 - i ) * i / 2;

	//shellrela[i] point to the ith row of up-triangel matrix shlrelfield.
	//shellrela[i][j-i-1] point out the geometry relation of shell[i] and shell[j]

	//Init relations between different objects
	objectrela =
		( ShellRelation ** ) malloc ( ( objno - 1 ) * sizeof ( ShellRelation * ) );
	objrelfield =
		( ShellRelation * ) malloc ( ( objno * ( objno - 1 ) / 2 ) *
									 sizeof ( ShellRelation ) );
	for ( i = 0; i < objno - 1; i++ )
		objectrela[i] = objrelfield + ( objno + objno - 1 - i ) * i / 2;

	for ( i = 0; i < shlno; i++ )
		for ( j = i + 1; j < shlno; j++ )
			shellrela[i][j - i - 1] = setshellrelation ( shell[i], shell[j] );

	verttotal = 10;
	edgetotal = 10;
	forceedgetotal = 10;
	naturaledgetotal = 10;
	borderedgetotal = 10;
	vertnum = 0;
	edgenum = 0;
	forceedgenum = 0;
	naturaledgenum = 0;
	borderedgenum = 0;
	vertrealloc = 0;
	edgerealloc = 0;			//Times of realloc edge
	forcerealloc = 0;
	naturalrealloc = 0;
	borderrealloc = 0;
	vert = ( Vert ** ) malloc ( sizeof ( Vert * ) );
	edge = ( Edge ** ) malloc ( sizeof ( Edge * ) );
	forceedge = ( Edge ** ) malloc ( sizeof ( Edge * ) );
	naturaledge = ( Edge ** ) malloc ( sizeof ( Edge * ) );
	borderedge = ( Edge ** ) malloc ( sizeof ( Edge * ) );
	vert[0] = ( Vert * ) malloc ( verttotal * sizeof ( Vert ) );
	edge[0] = ( Edge * ) malloc ( edgetotal * sizeof ( Edge ) );
	forceedge[0] = ( Edge * ) malloc ( forceedgetotal * sizeof ( Edge ) );
	naturaledge[0] = ( Edge * ) malloc ( naturaledgetotal * sizeof ( Edge ) );
	borderedge[0] = ( Edge * ) malloc ( borderedgetotal * sizeof ( Edge ) );

	//Get edges of all shapes
	for ( i = 0; i < objno; i++ )
		for ( j = 0; j < obj[i]->shellnum; j++ ) {
			createedgeforshape ( obj[i], obj[i]->shell[j] );
			//yuwj comment. Really create edge's elenum here!!
		}

	/*
	 * printf("Edges before shape calculation\n");
	 * for(i=0;i<objno;i++)
	 * for(j=0;j<obj[i]->shellnum;j++)
	 * {
	 * printf(i: %d,j: %d\n",i,j);
	 * printshapeedge(obj[i]->shell[j]->edge);
	 * }
	 */
	//Different shells in a same object
	for ( i = 0; i < objno; i++ )
		for ( j = 0; j < obj[i]->shellnum; j++ )
			for ( i1 = j + 1; i1 < obj[i]->shellnum; i1++ ) {
				shl1 = obj[i]->shell[j]->shellno;
				shl2 = obj[i]->shell[i1]->shellno;
				if ( shl1 > shl2 )
					sr = shellrela[shl2][shl1 - shl2 - 1];
				else
					sr = shellrela[shl1][shl2 - shl1 - 1];
				switch ( sr ) {
					case SEPERATE:
						break;
					case IN:
					case MERGEIN:
					case OUT:
					case MERGEOUT:
					case MERGE:
						//Two shapes in a same medium should be handle
					case INTERSECT:
					case ADJOIN:
						//Merge two shapes
						shapesinsameobj ( shell[shl1], shell[shl2], sr );
						break;
				}
			}
	/*
	 * printf("Edges before shape calculation\n");
	 * for(i=0;i<objno;i++)
	 * for(j=0;j<obj[i]->shellnum;j++)
	 * {
	 * printf(i: %d,j: %d\n",i,j);
	 * printshapeedge(obj[i]->shell[j]->edge);
	 * }
	 */

	for ( i = 0; i < objno; i++ )
		for ( j = 0; j < obj[i]->shellnum; j++ ) {
			//if(removeresidualedge(obj[i]->shell[j])==1)
			//	printf("remove %d obj %d shell successs\n",i,j);    //added by ysy
			if ( obj[i]->shell[j]->edge == NULL ) ;
			//printf("obj[%d]->shell[%d] has no edge\n",i,j);
		}
	//if any vert has no edge relatived,it should be removed,but have not done yet
	//medium and medium

	for ( i = 0; i < medobjnum; i++ )	//every medium
		for ( j = i + 1; j < medobjnum; j++ )	//other mediums
			for ( i1 = 0; i1 < medobj[i]->shellnum; i1++ )	//its all shapes
				for ( j1 = 0; j1 < medobj[j]->shellnum; j1++ ) {
					shl1 = medobj[i]->shell[i1]->shellno;
					shl2 = medobj[j]->shell[j1]->shellno;
					sr = setshellrelation ( shell[shl1], shell[shl2] );
					if ( sr != SEPERATE )
						shapesindiffmed ( shell[shl1], shell[shl2], sr );
				}

	//Check different conductors,if they are intersected
	//Which must means error
	for ( i = 0; i < condobjnum; i++ )	//every conductor
		for ( j = i + 1; j < condobjnum; j++ )	//other conductors
			for ( i1 = 0; i1 < condobj[i]->shellnum; i1++ )	//its all shapes
				for ( j1 = 0; j1 < condobj[j]->shellnum; j1++ ) {
					shl1 = condobj[i]->shell[i1]->shellno;
					shl2 = condobj[j]->shell[j1]->shellno;
					sr = setshellrelation ( shell[shl1], shell[shl2] );
					if ( sr != SEPERATE )
						shapesindiffcond ( shell[shl1], shell[shl2], sr );
				}

	//Create mediums chain fit to BEM
	//Each corresponding to a medium object
	med = ( Medium * ) malloc ( medobjnum * sizeof ( Medium ) );
	condnum = 4 * condobjnum;	//conductor number may change
	cond = ( Conductor * ) malloc ( condnum * sizeof ( Conductor ) );
	//Attention 1
	//cond should be process similar as edge,
	//but that means much modification,so just init an enough size
	mednum = medobjnum;			//medium number is stable
	condno = 0;

	//Initial of conductor
	for ( i = 0; i < condnum; i++ ) {
		cond[i].edgenum = 0;
		cond[i].edge = NULL;
		cond[i].mediumno = -1;
		cond[i].portno = -1;
		cond[i].condno = -1;
		cond[i].maxx = cond[i].maxy = -10000;
		cond[i].minx = cond[i].miny = 10000;
		cond[i].close = 1;
	}

	//Every conductor shell's edge number
	for ( i = 0; i < condobjnum; i++ )
		for ( j = 0; j < condobj[i]->shellnum; j++ ) {
			shl = condobj[i]->shell[j];
			shl->edgenum = 0;
			for ( se = shl->edge; se != NULL; se = se->next )
				shl->edgenum++;
		}

	//Initial of every medium
	for ( i = 0; i < medobjnum; i++ ) {
		med[i].mediumno = i;
		strcpy ( med[i].name, medobj[i]->name );
		med[i].diel = medobj[i]->rhoval;    //for residance calculation and use a same name
		med[i].edgenum = 0;
		med[i].condnum = 0;
		//Edge **edge; int condnum; Conductor **cond;int edgenum;
		med[i].edge = ( Edge ** ) malloc ( _edgeCount * sizeof ( Edge * ) );
		//200 could be changed to a larger number if memory error, by ysy 13.1.11
		//solved by yuwj,by setting _edgeCount automatically.
		med[i].edgevalidity = ( Bool * ) malloc ( _edgeCount * sizeof ( Bool ) );
		med[i].cond = NULL;
		//med[i].cond=(Conductor **)malloc(sizeof(Conductor *));
		//mark:pay attantion to this initial value

		//NATURAL and BORDER are add into medium
		for ( j = 0; j < medobj[i]->shellnum; j++ ) {
			se = medobj[i]->shell[j]->edge;
			for ( c1 = se; c1 != NULL; c1 = c1->next ) {
				if ( med[i].edgenum++ >= _edgeCount ) {
					//yuwj, will not come here!
					med[i].edge =
						( Edge ** ) realloc ( ( void * ) med[i].edge,
											  ( med[i].edgenum +
												1 ) * sizeof ( Edge * ) );
					med[i].edgevalidity =
						( Bool * ) realloc ( med[i].edgevalidity,
											 ( med[i].edgenum + 1 ) * sizeof ( Bool ) );
				}
				ed = createnewmededge ( c1->ed );
				//Get data from naturaledge[]
				//or borderedge[]
				filledgefield ( ed, c1->ed );	//copy c1->ed to ed

				med[i].edge[med[i].edgenum - 1] = ed;
				med[i].edgevalidity[med[i].edgenum - 1] = TRUE;
				ed->condno = 0;
				ed->portno = 0;
			}
		}
		med[i].validedgenum = med[i].edgenum;
	}

	//yuwj debug.  Now, adjust the elenum of all edges.
	//autoflag means auto element partition.
	int totalele;
	if ( autoflag ) {
		printf("\nUse auto divide.");
		double elegap = 100000;
		double edgelen;
		for ( i = 0; i < medobjnum; i++ ) {		//Determine minimum edge length
			for ( j = 0; j < med[i].edgenum; j++ ) {
				ed = med[i].edge[j];
				ed->dx = ( ed->e->x - ed->s->x );
				ed->dy = ( ed->e->y - ed->s->y );

				edgelen = sqrt ( ed->dx * ed->dx + ed->dy * ed->dy );
				//printf("edgelen= %f\n",edgelen);
				if ( edgelen < elegap )
					elegap = edgelen;
			}
		}
		//printf("minimum edgelen= %f\n",elegap);

		elegap = elegap /4 ;	//yuwj change 3 to 4; Apr.4, 2014
		totalele = 0;
		for ( i = 0; i < medobjnum; i++ ) {		//Make nonuniform partition
			for ( j = 0; j < med[i].edgenum; j++ ) {
				ed = med[i].edge[j];
				edgelen = sqrt ( ed->dx * ed->dx + ed->dy * ed->dy );
				ed->elenum = ( int ) ( edgelen / elegap + 0.5 );
				//printf("elenum= %d\n",ed->elenum);
				if ( ed->elenum > 50 )
					ed->elenum = ( int ) ( ed->elenum / 1.5 );
				if ( ed->elenum > 80 )
					ed->elenum = ( int ) ( ed->elenum / 2 );
				if ( ed->elenum > 100 )
					ed->elenum = 100;
				totalele += ed->elenum;
			}
		}
		printf("\ntotalele=%d.",totalele);
		if ( totalele > 5000 ) {	//Rescale the element partition
			double ratio = totalele / 3000;
			totalele = 0;
			for ( i = 0; i < medobjnum; i++ ) {
				for ( j = 0; j < med[i].edgenum; j++ ) {
					ed = med[i].edge[j];
					ed->elenum = ( int ) ( ed->elenum / ratio );
					if ( ed->elenum < 2 )
						ed->elenum = 2;
					totalele += ed->elenum;
				}
			}
			printf ( "After rescale, total element number is %d\n", totalele );
		}
	}		//autoflag means auto element partition. yuwj	
	else {
		for ( i = 0; i <shlno-condobjnum; i++ )
			realpolynum++;

		if ( divflag == FALSE || realeles != realpolynum ){
			printf( "\nError: There is no define element in the input file!\n" );
			printf( "Please use the parameter [-a] in the command!\n" );
			exit(0);
		}
		else{ 
			printf("\nUse define element to divide.");
			totalele = 0;
			for ( i = 0; i < medobjnum; i++ ) {		//Make nonuniform partition
				for ( j = 0; j < med[i].edgenum; j++ ) {
					ed = med[i].edge[j];
					totalele += ed->elenum;
				}
			}
			printf("\ntotalele=%d.",totalele);
		}
	}
	/*  //print elenum of each edge. yuwj
	 *  printf("After adjustment\n");
	 *  for(i=0;i<medobjnum;i++)
	 *  {
	 *  for(j=0;j<med[i].edgenum;j++)
	 *  {
	 *  ed=med[i].edge[j];
	 *  printf("elenum=%d\n,ed->elenum);
	 *  }
	 *  }
	 */

	neednewcond = FALSE;
	//After thinking and several times of changing,now I think setting
	//cond as outer loop and med as inter loop is better
	//in *cond, they are sorted by different portno from 0 to condobjnum
	//in med->cond, they are all belong to a same medium
	//So we can access conds by two kinds of sequence
	for ( i = 0; i < condobjnum; i++ )
		for ( j = 0; j < medobjnum; j++ ) {
			neednewcond = FALSE;
			cond[condno].mediumno = j;	  //The current cond,not used yet,initialized as 0th
			//If cond[i] and med[j] has no public part,
			//It won't be used and will be alternated next time

			cond[condno].condno = condno;
			//port No. is from 1 to condobjnum, not 0 to condobjnum-1!!!
			cond[condno].portno = i + 1;
			for ( j1 = 0; j1 < medobj[j]->shellnum; j1++ )
				for ( i1 = 0; i1 < condobj[i]->shellnum; i1++ ) {
					shl1 = condobj[i]->shell[i1]->shellno;
					shl2 = medobj[j]->shell[j1]->shellno;
					sr = setshellrelation ( shell[shl1], shell[shl2] );
					if ( sr != SEPERATE )
						if ( condandmed ( med + j, shell[shl1], shell[shl2], sr ) == TRUE )
							neednewcond = TRUE;
				}
			if ( neednewcond == TRUE ) {
				strcpy ( cond[condno].name, condobj[i]->name );
				condno++;
			}

			if ( neednewcond == TRUE ) {	//Last cond* of this med be used
				med[j].condnum++;
				if ( med[j].cond == NULL ) {
					med[j].cond =
						( Conductor ** ) malloc ( med[j].condnum *
												  sizeof ( Conductor * ) );
					med[j].cond[0] = cond + condno - 1;
				}
				else {
					med[j].cond =
						( Conductor ** ) realloc ( ( char * ) med[j].cond,
												   med[j].condnum *
												   sizeof ( Conductor * ) );
					med[j].cond[med[j].condnum - 1] = cond + condno - 1;
				}
			}
		}

	for ( i = 0; i < mednum; i++ ) {
		i1 = 0;
		for ( j = 0; j < med[i].edgenum; j++ )
			if ( med[i].edgevalidity[j] == TRUE )
				med[i].edge[i1++] = med[i].edge[j];
		med[i].edgenum = i1;  //med[i].validedgenum
		free ( ( char * ) med[i].edgevalidity );
	}

	condnum = condno;

	master = -1;
	j = 0;
	for ( i = 0; i < condobjnum; i++ )
		if ( calcarray[i] == 1 ) {
			master = i;
			j++;
		}

	for ( i = 0; i < objno; i++ ) {
		for ( j = 0; j < obj[i]->shellnum; j++ ) {    //added by ysy, 2/27/2013
			freese = obj[i]->shell[j]->edge;
			while ( freese != NULL ) {
				//printf("Edge from Obj %d shell %d is freed\n",i,j);
				freese1 = freese->next;
				free ( freese->po );
				//free(freese->ed);
				free ( freese );
				freese = freese1;
			}
			free ( freese );
			freepoly = obj[i]->shell[j]->shape.ppoly;
			free ( freepoly->eles );
			free ( freepoly->vertex );
			free ( freepoly );
			free ( ( char * ) obj[i]->shell[j] );
		}

	}

	free ( ( char * ) obj );
	free ( ( char * ) shell );
	free ( ( char * ) shellrela );
	free ( ( char * ) shlrelfield );
}

void createedgeforshape ( Object *o, Shell *s )
{
	switch ( s->shapetype ) {
		case BOX:
			createedgeforbox ( o, s, s->shape.bbox );
			break;
		case POLY:
			createedgeforpoly ( o, s, s->shape.ppoly );
			break;
		default:
			break;
	}
}

ShapeEdge *createshapeedge()
{
	ShapeEdge *se;

	se = ( ShapeEdge * ) malloc ( sizeof ( ShapeEdge ) );
	se->ed = NULL;
	se->po = NULL;
	se->pointnum = 0;
	se->next = NULL;
	return ( se );
}

Edge *createnewedge()
{

	Edge *ed;

	if ( edgenum >= edgetotal ) {
		edgetotal += 10;
		edgerealloc++;
		edge =
			( Edge ** ) realloc ( ( char * ) edge, ( edgerealloc + 1 ) * sizeof ( Edge * ) );
		edge[edgerealloc] = ( Edge * ) malloc ( 10 * sizeof ( Edge ) );
	}
	// edge[edgenum].edgeno=edgeno++;
	if ( edgerealloc == 0 )
		ed = edge[0] + edgenum;
	else
		ed = edge[edgerealloc] + 10 - ( edgetotal - edgenum );
	edgenum++;
	ed->stype = 0;
	ed->etype = 0;
	ed->sno = 0;
	ed->eno = 0;

	return ( ed );
}

Edge *createnewforceedge()
{
	Edge *ed;

	if ( forceedgenum >= forceedgetotal ) {
		forceedgetotal += 10;
		forcerealloc++;
		forceedge =
			( Edge ** ) realloc ( ( char * ) forceedge,
								  ( forcerealloc + 1 ) * sizeof ( Edge * ) );
		forceedge[forcerealloc] = ( Edge * ) malloc ( 10 * sizeof ( Edge ) );
	}
	//forceedge[forceedgenum].edgeno=edgeno++;
	if ( forcerealloc == 0 )
		ed = forceedge[0] + forceedgenum;
	else
		ed = forceedge[forcerealloc] + 10 - ( forceedgetotal - forceedgenum );
	forceedgenum++;
	return ( ed );
}

Edge *createnewmededge ( Edge *e )
{
	Edge *ed;

	if ( e->electype == NATURAL ) {
		if ( naturaledgenum >= naturaledgetotal ) {
			naturaledgetotal += 10;
			naturalrealloc++;
			naturaledge =
				( Edge ** ) realloc ( ( char * ) naturaledge,
									  ( naturalrealloc + 1 ) * sizeof ( Edge * ) );
			naturaledge[naturalrealloc] = ( Edge * ) malloc ( 10 * sizeof ( Edge ) );
		}
		//naturaledge[naturaledgenum].edgeno=edgeno++;
		if ( naturalrealloc == 0 )
			ed = naturaledge[0] + naturaledgenum;
		else
			ed = naturaledge[naturalrealloc] + 10 - ( naturaledgetotal -
					naturaledgenum );
		naturaledgenum++;
		return ( ed );
	}
	else {						//BORDER
		if ( borderedgenum >= borderedgetotal ) {
			borderedgetotal += 10;
			borderrealloc++;
			borderedge =
				( Edge ** ) realloc ( ( char * ) borderedge,
									  ( borderrealloc + 1 ) * sizeof ( Edge * ) );
			borderedge[borderrealloc] = ( Edge * ) malloc ( 10 * sizeof ( Edge ) );
		}
		//borderedge[borderedgenum].edgeno=edgeno++;
		if ( borderrealloc == 0 )
			ed = borderedge[0] + borderedgenum;
		else
			ed = borderedge[borderrealloc] + 10 - ( borderedgetotal -
													borderedgenum );
		borderedgenum++;
		return ( ed );
	}
}

void filledgefield ( Edge *d, Edge *s )
{
	d->edgeno = s->edgeno;
	d->edgetype = s->edgetype;
	d->electype = s->electype;
	d->medium = s->medium;
	d->reversemed = s->reversemed;
	d->reverseedge = s->reverseedge;    //no use maybe
	d->s = s->s;
	d->e = s->e;
	d->elenum = s->elenum;
	d->stype = s->stype;
	d->etype = s->etype;
	d->sno = s->sno;
	d->eno = s->eno;

	d->A = s->A;
	d->B = s->B;
	d->C = s->C;
	d->maxx = s->maxx;
	d->maxy = s->maxy;
	d->minx = s->minx;
	d->miny = s->miny;

}

void setedgescope ( Edge *ed )
{
		setlinescope ( ed );
}

/* see 'at () to ()' in y2 get as & ae from s & e (may add '=' there)
 * and setarcshell() in shape.c get minxy,maxxy
 */

void setlinescope ( Edge *ed )
{
		if ( Less ( ed->s->x, ed->e->x ) ) {
			ed->maxx = ed->e->x;
			ed->minx = ed->s->x;
		}
		else {
			ed->maxx = ed->s->x;
			ed->minx = ed->e->x;
		}
		if ( Less ( ed->s->y, ed->e->y ) ) {
			ed->maxy = ed->e->y;
			ed->miny = ed->s->y;
		}
		else {
			ed->maxy = ed->s->y;
			ed->miny = ed->e->y;
		}
//	}
}

void createedgeforbox ( Object *o, Shell *s, Box *b )
{
	Edge *ed = NULL;
	ShapeEdge *cur = NULL;

	s->edge = NULL;
	s->edge = createshapeedge();
	cur = s->edge;

	ed = createnewedge();
	if ( o->electype == MEDIUM )
		ed->medium = o->mediumno;
	createvertforedge ( ed, b->x1, b->y1, b->x2, b->y2 );
	if ( o->electype == MEDIUM )
		ed->electype = NATURAL;
	else
		ed->electype = FORCE;
	ed->edgetype = LINE;
	ed->elenum = b->elesonwidth;
	setlinescope ( ed );
	setequationofline ( ed );
	cur->ed = ed;
	cur->next = createshapeedge();
	cur = cur->next;

	ed = createnewedge();
	if ( o->electype == MEDIUM )
		ed->medium = o->mediumno;
	createvertforedge ( ed, b->x2, b->y2, b->x3, b->y3 );
	if ( o->electype == MEDIUM )
		ed->electype = NATURAL;
	else
		ed->electype = FORCE;
	ed->edgetype = LINE;
	ed->elenum = b->elesonheight;
	setlinescope ( ed );
	setequationofline ( ed );
	cur->ed = ed;
	cur->next = createshapeedge();
	cur = cur->next;

	ed = createnewedge();
	if ( o->electype == MEDIUM )
		ed->medium = o->mediumno;
	createvertforedge ( ed, b->x3, b->y3, b->x4, b->y4 );
	if ( o->electype == MEDIUM )
		ed->electype = NATURAL;
	else
		ed->electype = FORCE;
	ed->edgetype = LINE;
	ed->elenum = b->elesonwidth;
	setlinescope ( ed );
	setequationofline ( ed );
	cur->ed = ed;
	cur->next = createshapeedge();
	cur = cur->next;

	ed = createnewedge();
	if ( o->electype == MEDIUM )
		ed->medium = o->mediumno;
	createvertforedge ( ed, b->x4, b->y4, b->x1, b->y1 );
	if ( o->electype == MEDIUM )
		ed->electype = NATURAL;
	else
		ed->electype = FORCE;
	ed->edgetype = LINE;
	ed->elenum = b->elesonheight;
	setlinescope ( ed );
	setequationofline ( ed );
	cur->ed = ed;
	cur->next = NULL;
}

void createedgeforpoly ( Object *o, Shell *s, Poly *p )
{
	Edge *ed = NULL;
	ShapeEdge *cur = NULL;
	int i;

	s->edge = createshapeedge();
	cur = s->edge;

	/* 
	 * printf("\n");
	 * printf("%d\n",p->vertnum);
	 */

	for ( i = 0; i < p->vertnum - 1; i++ ) {
		ed = createnewedge();
		ed->elenum = p->eles[i];
		//printf("p->eles[i]=%d\n",p->eles[i]);
		if ( o->electype == MEDIUM )
			ed->medium = o->mediumno;
		createvertforedge ( ed, p->vertex[i].x, p->vertex[i].y,
							p->vertex[i + 1].x, p->vertex[i + 1].y );

		if ( o->electype == MEDIUM )
			ed->electype = NATURAL;
		else
			ed->electype = FORCE;
		ed->edgetype = LINE;
		setlinescope ( ed );
		setequationofline ( ed );
		cur->ed = ed;
		if ( i == p->vertnum - 2 )
			cur->next = NULL;
		else {
			cur->next = createshapeedge();
			cur = cur->next;
		}
	}
}

void persue ( double *lmd, double *miu, double *d, double *al, int n, int s )
{
	int j;
	double *p, *a, *b;

	p = ( double * ) malloc ( s * sizeof ( double ) );
	a = ( double * ) malloc ( s * sizeof ( double ) );
	b = ( double * ) malloc ( s * sizeof ( double ) );
	a[1] = -miu[1] / 3.0;
	a[1] = 0.0;
	b[1] = d[1] / 3.0;
	for ( j = 2; j <= n - 1; j++ ) {
		p[j] = 3 + lmd[j] * a[j - 1];
		a[j] = -miu[j] / p[j];
		b[j] = ( d[j] - lmd[j] * b[j - 1] ) / p[j];
	}
	a[n - 1] = -a[n - 1];
	for ( j = 1; j <= n - 1; j++ )
		al[n - j] = al[n - j + 1] * a[n - j] + b[n - j];

	free ( ( char * ) p );
	free ( ( char * ) a );
	free ( ( char * ) b );
}

void createvertforedge ( Edge *ed, double x1, double y1, double x2, double y2 )
{
	ed->s = searchvert ( x1, y1 );
	if ( ed->s == NULL ) {
		ed->s = createnewvert();
		ed->s->x = x1;
		ed->s->y = y1;
		ed->s->edgenum = 1;
	}
	else
		ed->s->edgenum++;

	ed->e = searchvert ( x2, y2 );
	if ( ed->e == NULL ) {
		ed->e = createnewvert();
		ed->e->x = x2;
		ed->e->y = y2;
		ed->e->edgenum = 1;
	}
	else
		ed->e->edgenum++;
}

Vert *searchvert ( double x, double y )
{
	Vert *v = NULL;
	int i;

	for ( i = 0; i < vertnum; i++ ) {
		v = vert[i / 10] + i % 10;
		if ( ptEqual ( v->x, x ) && ptEqual ( v->y, y ) )
			return ( v );
	}
	return ( NULL );
}

Vert *createnewvert()
{
	Vert *v = NULL;

	if ( vertnum >= verttotal ) {
		verttotal += 10;
		vertrealloc++;
		vert =
			( Vert ** ) realloc ( ( char * ) vert, ( vertrealloc + 1 ) * sizeof ( Vert * ) );
		vert[vertrealloc] = ( Vert * ) malloc ( 10 * sizeof ( Vert ) );
	}
	if ( vertrealloc == 0 )
		v = vert[0] + vertnum;
	else
		v = vert[vertrealloc] + 10 - ( verttotal - vertnum );
	vertnum++;
	return ( v );
}

void shapesinsameobj ( Shell *s1, Shell *s2, ShellRelation sr )
{
	ShapeEdge *c1 = NULL, *c2 = NULL;
	ShapeEdge *se1 = NULL, *se2 = NULL;
	ShapeEdge *se = NULL, *see = NULL;
	Edge *e1 = NULL, *e2 = NULL;
	Edge *ed = NULL, *edd = NULL;
	Flag f1;	//f1==0 means e1 has been deleted, so break out

	se1 = s1->edge;
	se2 = s2->edge;
	for ( c1 = se1; c1 != NULL; c1 = c1->next ) {
		e1 = c1->ed;
		f1 = 1;
		for ( c2 = se2; c2 != NULL; c2 = c2->next ) {
			e2 = c2->ed;
			switch ( edgerelation ( e1, e2 ) ) {
				case DISCONNECT:
					break;
				case CONNECT:
					break;
				case REVERSECONNECT:
					break;
				case SAMESTART:
					break;
				case SAMEEND:
					break;
				case SHARELINE:
					f1 = sharelineinsameobj ( s1, s2, c1, c2, e1, e2 );
					break;
				case CROSS:
					crossinsameobj ( c1, c2, e1, e2 );
					break;
				default:
					break;
			}    //switch DISCONNECT,SHARELINE,CROSS,...
			if ( f1 == 0 )
				break;			//Need a new c1 because the old one had been deleted
		}						//for c2
		if ( f1 == 0 )
			break;				//added by ysy, 3/4/2013
	}							//for c1
	se1 = s1->edge;
	se2 = s2->edge;
	see = se1;
	for ( c1 = se1; c1 != NULL; c1 = c1->next ) {
		e1 = c1->ed;
		int i;
		/*
		 * for(i=0;i<c1->pointnum;i++)
		 * 		printf("(%6.2f,%6.2f)\n",c1->po[i]->x,c1->po[i]->y);
		 */
		if ( c1->pointnum != 0 ) {	//2  or  4
			e1->s->edgenum--;
			e1->e->edgenum--;
			e1->s = c1->po[0];
			e1->e = c1->po[1];
			e1->s->edgenum++;
			e1->e->edgenum++;
			e1->elenum = ( e1->elenum - 1 ) / 2 + 1;	//Depart to the half
			setedgescope ( e1 );
		}
		if ( c1->pointnum == 4 ) {
			se = createshapeedge();
			ed = createnewedge();
			filledgefield ( ed, e1 );
			ed->s = c1->po[2];
			ed->e = c1->po[3];
			ed->s->edgenum++;
			ed->e->edgenum++;
			setedgescope ( ed );
			setequationofline ( ed );
			se->ed = ed;
			see = addedge ( see, c1, se, 1 );
		}
		c1->pointnum = 0;
	}
	s1->edge = see;
	see = se2;
	for ( c2 = se2; c2 != NULL; c2 = c2->next ) {
		e2 = c2->ed;
		if ( c2->pointnum != 0 ) {	//2  or  4
			e2->s->edgenum--;
			e2->e->edgenum--;
			e2->s = c2->po[0];
			e2->e = c2->po[1];
			e2->s->edgenum++;
			e2->e->edgenum++;
			e2->elenum = ( e2->elenum - 1 ) / 2 + 1;	//Depart to the half
			setedgescope ( e2 );
		}
		if ( c2->pointnum == 4 ) {
			se = createshapeedge();
			ed = createnewedge();
			filledgefield ( ed, e2 );
			ed->s = c2->po[2];
			ed->e = c2->po[3];
			ed->s->edgenum++;
			ed->e->edgenum++;
			setedgescope ( ed );
			setequationofline ( ed );
			se->ed = ed;
			see = addedge ( see, c2, se, 1 );
		}
		c2->pointnum = 0;
	}
	s2->edge = see;
}

void shapesindiffcond ( Shell *s1, Shell *s2, ShellRelation sr )
{
	ShapeEdge *c1 = NULL, *c2 = NULL;
	ShapeEdge *se1 = NULL, *se2 = NULL;
	Edge *e1 = NULL, *e2 = NULL;

	se1 = s1->edge;
	se2 = s2->edge;
	for ( c1 = se1; c1 != NULL; c1 = c1->next ) {
		e1 = c1->ed;
		for ( c2 = se2; c2 != NULL; c2 = c2->next ) {
			e2 = c2->ed;
			switch ( edgerelation ( e1, e2 ) ) {
				case DISCONNECT:
					break;
				case CONNECT:
				case REVERSECONNECT:
				case SAMESTART:
				case SAMEEND:
				case SHARELINE:
				case CROSS:
					printf ( "Errors between these two conductors!\n" );
					printf ( "Edges in different conductors cannot be touched\n" );
					exit ( 15 );
					break;
				default:
					break;
			}
		}
	}
}

Bool condandmed ( Medium *m, Shell *s1, Shell *s2, ShellRelation sr )
{
	Bool neednewcond;

	switch ( sr ) {
		case SEPERATE:
			break;
		case ADJOIN:
		case IN:
		case MERGEIN:
		case MERGEOUT:
		case OUT:
			//Out cases must be handled, because IN or OUT is decided by
			//there turns in the input file
		case INTERSECT:
		case MERGE:
			neednewcond = cmINTER ( m, s1, s2 );
			break;
	}
	return ( neednewcond );
}

//Here, waitedforhandle should be move to out loop of s2, which means
//only included by cond and med loop in function shapecalculation()
//If med is composed by several parts of edges, we can't distinguish
//whether a cond edge is in or out the whole med.
//But I think this case may seldom occur in really examples,
//see also case a20.
//If force edges are the two vertical but not horizontal, it will be wrong
Bool cmINTER ( Medium *m, Shell *s1, Shell *s2 )
{
	//If TRUE after e1 loop, means e1 does not connect with any of medium edge
	//must be inside or outside.
	ShapeEdge *c1 = NULL, *c2 = NULL;
	Bool neednewcond = FALSE;
	Edge *e1 = NULL, *e2 = NULL, *ed2 = NULL;
	EdgeRelation rela;
	int i = 0;					//the ith edge of conductor shell s1
	int j;
	double x, y, ang;
	Bool *waitforhandle = NULL;
	Bool inshell;
	waitforhandle = ( Bool * ) malloc ( s1->edgenum * sizeof ( Bool ) );
	Vert **cross, **cr;
	Vert *cr1, *cr2;
	Vert *tmp;
	int i1, j1, ic, cpnum;
	//Suppose times that e1 intersect with the med can not be greater than fourth
	//Bool waitforhandle[200];

	for ( c1 = s1->edge; c1 != NULL; c1 = c1->next ) {
		e1 = c1->ed;
		cpnum = 0;				//No cross point in e1 now
		//This force edge is not relative to any medium edge
		waitforhandle[i++] = TRUE;

		for ( c2 = s2->edge; c2 != NULL; c2 = c2->next ) {
			e2 = c2->ed;
			rela = edgerelation ( e1, e2 );
			switch ( rela ) {
				case CONNECT:
				case DISCONNECT:
				case REVERSECONNECT:
				case SAMESTART:
				case SAMEEND:
					break;
				case SHARELINE:
					if ( neednewcond == FALSE )
						neednewcond = condandmedshareline ( m, c2, e1, e2 );
					else
						condandmedshareline ( m, c2, e1, e2 );
					waitforhandle[i - 1] = FALSE;
					break;
				case CROSS:
					ed2 =
						condandmedcross ( m, s2, c1, c2, e1, e2, cr,
										  waitforhandle + i - 1 );
					break;
				default:
					break;
			}    //switch
			/*
			 * can't break.
			 * maybe e1 is relative with another edge of this same med.See the long cond in s2
			 * if(waitforhandle[i-1]==FALSE)
			 * break;       this e1 is handled,
			 */
		}

		/* there's two cases while cpnum>0
		 * 1. ed2!=NULL,the force edge need to add is decided
		 * 2. ed2==NULL,only cut it and add to med while still waited for handle
		 * case 2 is modified on 990827,maybe still has errors
		 * cpnum=1 or 2 mark
		 */
		cpnum = c1->pointnum;
		//printf("cpnum=%d\n",cpnum);

		ic = cpnum - 1;
		if ( ed2 != NULL ) {
			if ( cpnum == 1 ) {
				if ( addedgetomed ( m, ed2 ) != NULL )
					addedgetocond ( m, cond + condno, ed2 );
				neednewcond = TRUE;
			}
			else {		//Multi cross point
				while ( ic >= 0 ) {		//Some cross point between e1 and the med
					cross = c1->po;
					for ( i1 = 0; i1 < cpnum; i1++ )	//Adjust the sequence of cross point
						for ( j1 = i1 + 1; j1 < cpnum; j1++ ) {
							if ( pointLess ( e1->s, e1->e ) )
								if ( pointLess ( cross[j1], cross[i1] ) ) {
									tmp = cross[i1];
									cross[i1] = cross[j1];
									cross[j1] = tmp;
								}
							if ( pointLess ( e1->e, e1->s ) )
								if ( pointLess ( cross[i1], cross[j1] ) ) {
									tmp = cross[i1];
									cross[i1] = cross[j1];
									cross[j1] = tmp;
								}
						}
					filledgefield ( ed2, e1 );
					if ( cpnum == 2 ) {
						ed2->s = cross[ic];
						ed2->e = cross[ic - 1];
					}
					ic -= 2;
					if ( addedgetomed ( m, ed2 ) != NULL )
						addedgetocond ( m, cond + condno, ed2 );
					neednewcond = TRUE;
				}
			}
		}
		//At first,e1 has no neighbour or intersect relation with the shell
		if ( waitforhandle[i - 1] == TRUE ) {	//IN or OUT of this medium
			inshell = FALSE;
			cr1 = cr2 = NULL;

	//		if ( e1->edgetype == LINE ) {
				if ( c1->pointnum == 0 ) {
					x = ( e1->e->x + e1->s->x ) / 2;
					y = ( e1->e->y + e1->s->y ) / 2;
					if ( pointinsideshell ( x, y, s2 ) )
						inshell = TRUE;
				}
				else if ( c1->pointnum == 1 )
				  //modifymark
					if ( pointinsideshell ( e1->s->x, e1->s->y, s2 ) ) {
						cr1 = e1->s;
						cr2 = c1->po[0];
						inshell = TRUE;
					}
					else {
						cr1 = c1->po[0];
						cr2 = e1->e;
						inshell = TRUE;
					}
				else if ( c1->pointnum == 2 )	//have not met yet
					if ( ( pow ( c1->po[0]->x - e1->s->x, 2 ) +
							pow ( c1->po[0]->y - e1->s->y,
								  2 ) ) > ( pow ( c1->po[1]->x - e1->s->x,
												  2 ) + pow ( c1->po[1]->y - e1->s->x, 2 ) ) ) {
						cr1 = c1->po[1];
						cr2 = c1->po[0];
						inshell = TRUE;
					}
					else {
						cr1 = c1->po[0];
						cr2 = c1->po[1];
						inshell = TRUE;
					}
				else			//pointnum>=3
					printf
					( "Too much point in an edge waiting for handle\n!!!\n" );
			if ( inshell ) {
				ed2 = createnewforceedge();
				filledgefield ( ed2, e1 );
				if ( cr2 != NULL )
					ed2->s = cr2;
				else
					ed2->s = e1->e;
				if ( cr1 != NULL )
					ed2->e = cr1;
				else
					ed2->e = e1->s;
				if ( addedgetomed ( m, ed2 ) != NULL )
					addedgetocond ( m, cond + condno, ed2 );
				neednewcond = TRUE;
			}
			//Now we judge if the middle point of edge is in shell
			//to determine whether e1 is in shell
		}
		c1->pointnum = 0;
	}	//next e1
	free ( ( char * ) waitforhandle );
	return ( neednewcond );
}
//suit for Tu1 poly.
//Only when v in all edges' inside
//v is really in s
Bool pointinsideshell ( double x, double y, Shell *s )
{
	ShapeEdge *c1 = NULL;
	Edge *e1 = NULL;

	for ( c1 = s->edge; c1 != NULL; c1 = c1->next ) {
		e1 = c1->ed;

		//triangle v,e1->s,e1->e
		//if s of this triangle is positive,
		//v is inside of e1
		//s of polygon is SIGMA(x[i]y[i+1]-y[i]x[i+1])

		if ( pointinsideedge ( x, y, e1 ) == FALSE )
			return ( FALSE );
	}
	return ( TRUE );
}

// v is belong to one of edges of s, v is on border of s
Bool pointonshell ( double x, double y, Shell *s )
{
	ShapeEdge *c1 = NULL;
	Edge *e1 = NULL;

	for ( c1 = s->edge; c1 != NULL; c1 = c1->next ) {
		e1 = c1->ed;
		if ( pointonedge ( x, y, e1 ) == TRUE )
			return ( TRUE );
	}
	return ( FALSE );
}

Bool pointinsideedge ( double x, double y, Edge *e1 )
{
	double s;
	double x1, y1, x2, y2;
	int part, i;

		s = x * e1->s->y - y * e1->s->x;
		s += e1->s->x * e1->e->y - e1->s->y * e1->e->x;
		s += e1->e->x * y - e1->e->y * x;
		if ( Less ( s, 0.0 ) )
			return ( FALSE );
		else
			return ( TRUE );
	//else if (e1->edgetype==ARCEDGE)  //treatment for it deleted by yuwj. 13.8.15
	assert ( 0 );
	return false;
}

Bool pointonedge ( double x, double y, Edge *e1 )
{
		if ( !Equal ( e1->A * x + e1->B * y + e1->C, 0 ) )
			return ( FALSE );
		else if ( Greater ( x, e1->maxx ) || Greater ( y, e1->maxy )
				  || Less ( x, e1->minx ) || Less ( y, e1->miny ) )
			return ( FALSE );
		else
			return ( TRUE );
	//else if (e1->edgetype==ARCEDGE)  //treatment for it deleted by yuwj. 13.8.15
	assert ( 0 );
	return false;
}

//This function determine if the edge is in box shell of the medium
//		----/----/--- may be think as IN
//So must know if it's intersect with some edges
Bool edgeisinshell ( Edge *ed, Shell *s )
{
	if ( Greater ( ed->maxx, s->maxx ) || Greater ( ed->maxy, s->maxy )
			|| Less ( ed->minx, s->minx ) || Less ( ed->miny, s->miny ) )
		return ( FALSE );
	else if ( pointinsideshell ( ed->s->x, ed->s->y, s ) )
		return ( TRUE );
	else
		return ( FALSE );
}

void addpoint ( ShapeEdge *se, Vert *v )
{
	int i, num = se->pointnum;

	//if(se->po==NULL)   //No point exists yet
	//if(num==0 || se->po==NULL)
	if ( num == 0 ) {		//Maybe point exists
		if ( se->po != NULL ) {
			free ( ( char * ) se->po );
		}
		se->po = ( Vert ** ) malloc ( 8 * sizeof ( Vert * ) );
		se->po[0] = v;
		se->pointnum = 1;
		return;
	}
	for ( i = 0; i < num; i++ )
		if ( Equal ( se->po[i]->x, v->x ) && Equal ( se->po[i]->y, v->y ) )
			return;
	if ( num % 8 == 0 )
		se->po = ( Vert ** ) realloc ( ( char * ) se->po, ( num + 8 ) * sizeof ( Vert * ) );
	se->po[num] = v;
	se->pointnum++;
	return;
}

Edge *condandmedcross ( Medium *m, Shell *s2, ShapeEdge *c1, ShapeEdge *c2,
						Edge *e1, Edge *e2, Vert **cr, Bool *flag )
{
	ShapeEdge *c0;
	Vert *cross;
	Edge *ed = NULL;
	Edge *ed2 = NULL;
	Edge *tmp = NULL;			//tmp is the real edge shoule be deleted from med
	//allready meet: 1,2,3,4

	cross = crosspoint ( e1, e2 );
	if ( cross == NULL )
		printf ( "Error:these two edges have no cross point\n" );
	else if ( cross == e2->e || cross == e2->s ) {	//cross point is vert of med edge
		if ( cross == e1->e || cross == e1->s ) {
		//do nothing
		//printf("cross type 1\n");
		}
		else {		//Maybe unfit with others
			addpoint ( c1, cross );
			//modifymark
		}
	}
	else if ( cross == e1->s )
		if ( pointinsideedge ( e1->e->x, e1->e->y, e2 ) ) {
			//printf("cross type 2\n");
			ed2 = createnewforceedge();
			filledgefield ( ed2, e1 );
			ed2->s = e1->e;
			ed2->e = e1->s;
			*flag = FALSE;
			if ( cross != e2->s ) {
				ed = createnewmededge ( e2 );
				//1 e2->elenum=(e2->elenum-1)/2+1;
				filledgefield ( ed, e2 );
				ed->s = cross;
				ed->e = getvert ( c2, cross, e2->e );
				deledgefrommed ( m, e2, getvert ( c2, cross, e2->s ),
								 getvert ( c2, cross, e2->e ) );
			}
			addpoint ( c2, cross );
			addpoint ( c1, cross );
		}
		else {	//e1 is outside s2
			*flag = FALSE;
			if ( cross != e2->s ) {
				ed = createnewmededge ( e2 );
				//1 e2->elenum=(e2->elenum-1)/2+1;
				filledgefield ( ed, e2 );
				ed->e = cross;
				ed->s = getvert ( c2, cross, e2->s );
				deledgefrommed ( m, e2, getvert ( c2, cross, e2->s ),
								 getvert ( c2, cross, e2->e ) );
			}
			// printf("cross type 3\n");
		}
	else if ( cross == e1->e )
		if ( pointinsideedge ( e1->s->x, e1->s->y, e2 ) ) {
			//mark 98.3.27
			//printf("cross type 4\n");
			ed2 = createnewforceedge();
			filledgefield ( ed2, e1 );
			ed2->s = e1->e;
			ed2->e = e1->s;
			*flag = FALSE;
			if ( cross != e2->e ) {
				ed = createnewmededge ( e2 );
				//1 e2->elenum=(e2->elenum-1)/2+1;
				filledgefield ( ed, e2 );
				ed->e = cross;
				ed->s = getvert ( c2, cross, e2->s );
				deledgefrommed ( m, e2, getvert ( c2, cross, e2->s ),
								 getvert ( c2, cross, e2->e ) );
			}
			addpoint ( c2, cross );
			addpoint ( c1, cross );
		}
		else {   //e1 is outside s2
			*flag = FALSE;
			if ( cross != e2->e ) {
				ed = createnewmededge ( e2 );
				//1 e2->elenum=(e2->elenum-1)/2+1;
				filledgefield ( ed, e2 );
				ed->s = cross;
				ed->e = getvert ( c2, cross, e2->e );
				deledgefrommed ( m, e2, getvert ( c2, cross, e2->s ),
								 getvert ( c2, cross, e2->e ) );
			}
			//printf("cross type 5\n");
		}
	else {	// cross is a really one
		//printf("cross type 6\n");
		ed2 = createnewforceedge();
		//1 e2->elenum=(e2->elenum-1)/2+1;
		filledgefield ( ed2, e1 );
		if ( pointinsideedge ( e1->s->x, e1->s->y, e2 ) ) {
			ed2->s = cross;
			//ed2->e=getvert(c1,cross,e1->s);
			//deledgefrommed(m,e1,getvert(c1,cross,e1->s),getvert(c1,cross,e1->e));
			ed2->e = e1->s;
			if ( cross != e2->e ) {
				ed = createnewmededge ( e2 );
		//1 e2->elenum=(e2->elenum-1)/2+1;
				filledgefield ( ed, e2 );
				ed->s = getvert ( c2, cross, e2->s );
				ed->e = cross;
				deledgefrommed ( m, e2, getvert ( c2, cross, e2->s ),
								 getvert ( c2, cross, e2->e ) );
			}
		}
		else {	// e1->e is inside s2
			//printf("cross type 1\n");
			//ed2->s=getvert(c1,cross,e1->e);
			ed2->e = cross;
			//deledgefrommed(m,e1,getvert(c1,cross,e1->s),getvert(c1,cross,e1->e));
			ed2->s = e1->e;
			if ( cross != e2->s ) {
				ed = createnewmededge ( e2 );
		//1 e2->elenum=(e2->elenum-1)/2+1;
				filledgefield ( ed, e2 );
				ed->s = cross;
				ed->e = getvert ( c2, cross, e2->e );
				deledgefrommed ( m, e2, getvert ( c2, cross, e2->s ),
								 getvert ( c2, cross, e2->e ) );
			}
		}
		*flag = FALSE;
		addpoint ( c2, cross );
		addpoint ( c1, cross );
	}	//really a cross
	/*
	 * printf("********\n");
	 * printanedge(e1);
	 * printanedge(e2);
	 * int i;
	 * for(i=0;i<c1->pointnum;i++)
	 * printpoint(c1->po[i]);
	 * printanedge(ed2);
	 * printanedge(ed);
	 * printf("********\n\n");
	 */
	
	if ( ed != NULL ) {
		setedgescope ( ed );
		addedgetomed ( m, ed );
	}
	cr = &cross;
	return ( ed2 );
}

Bool condandmedshareline ( Medium *m, ShapeEdge *c2, Edge *e1, Edge *e2 )
{
	short type;
	ShareLineDircRela dirc;
	Edge *ed = NULL, *ed2 = NULL;

	type = sharelinetype ( e1, e2 );
	dirc = sharelinedircrela ( e1, e2 );
	//already meet
	//				1-1		1-3
	//		    3-0 3-1	3-2 3-3
	//		    6-0 6-1 6-2 6-3
	//		    9-0 9-1 9-2 9-3
	//ed as new mededge
	//while ed2 as new forceedge;
	ed = NULL;
	ed2 = NULL;
	switch ( type ) {
		case 0:
			break;
		case 1:
		case 2:
			ed = createnewmededge ( e2 );
			filledgefield ( ed, e2 );

			//In order to reverse other attribute of e1
			//If hasn't others
			//Equal as ed->electype=FORCE
			switch ( dirc ) {
				case INTURN:
					ed->e = e1->s;
					ed->s = getvert ( c2, ed->e, e2->s );
					break;
				case REVERSE:
					ed->s = e1->e;
					ed->e = getvert ( c2, ed->s, e2->e );
					break;
				case FACE:
					//pass
					ed2 = createnewforceedge();
					filledgefield ( ed2, e1 );
					ed2->s = e2->s;
					ed2->e = e1->s;
					ed->s = e1->s;
					ed->e = getvert ( c2, ed->s, e2->e );
					break;
				case OPPOSITE:
					ed2 = createnewforceedge();
					filledgefield ( ed2, e1 );
					ed2->s = e1->e;
					ed2->e = e2->e;
					ed->e = e1->e;
					ed->s = getvert ( c2, ed->e, e2->s );
					break;
			}
			if ( dirc == INTURN || dirc == FACE ) {
				deledgefrommed ( m, e2, getvert ( c2, e1->s, e2->s ),
								 getvert ( c2, e1->s, e2->e ) );
				addpoint ( c2, e1->s );
			}
			else {
				deledgefrommed ( m, e2, getvert ( c2, e1->e, e2->s ),
								 getvert ( c2, e1->e, e2->e ) );
				addpoint ( c2, e1->e );
			}
			setlinescope ( ed );
			addedgetomed ( m, ed );
			break;
		case 3:
			deledgefrommed ( m, e2, getvert ( c2, e1->s, e2->s ),
							 getvert ( c2, e1->e, e2->e ) );
			ed = createnewmededge ( e2 );
			filledgefield ( ed, e2 );
			if ( dirc == FACE || dirc == OPPOSITE )
				ed->e = e1->e;
			else
				ed->e = e1->s;
			ed->s = getvert ( c2, ed->e, e2->s );
			setlinescope ( ed );
			addedgetomed ( m, ed );
			ed->elenum = ( e2->elenum - 1 ) / 2 + 1;

			ed = createnewmededge ( e2 );
			filledgefield ( ed, e2 );
			if ( dirc == FACE || dirc == OPPOSITE )
				ed->s = e1->s;
			else
				ed->s = e1->e;
			ed->e = getvert ( c2, ed->s, e2->e );
			setlinescope ( ed );
			addedgetomed ( m, ed );
			ed->elenum = ( e2->elenum - 1 ) / 2 + 1;

			if ( dirc == FACE || dirc == OPPOSITE ) {
				ed2 = createnewforceedge();
				filledgefield ( ed2, e1 );
				ed2->s = e1->e;
				ed2->e = e1->s;
			}
			addpoint ( c2, e1->s );
			addpoint ( c2, e1->e );
			break;
		case 4:
		case 5:
		case 7:
		case 8:
			deledgefrommed ( m, e2, e2->s, e2->e );
			if ( dirc == FACE || dirc == OPPOSITE ) {
				ed2 = createnewforceedge();
				filledgefield ( ed2, e1 );
				ed2->s = e2->s;
				ed2->e = e2->e;
			}
			//above is thought by txb98.3.12
			break;
		case 6:
		case 9:
			//combine 6 & 9 to one case, as 1 & 2  txb98.4.2
			ed = createnewmededge ( e2 );
			filledgefield ( ed, e2 );
			if ( dirc == INTURN )
				ed->s = e1->e;
			else if ( dirc == REVERSE )
				ed->e = e1->s;
			else {
				//FACE and OPPO
				ed2 = createnewforceedge();
				filledgefield ( ed2, e1 );
				if ( dirc == FACE ) {
					ed->e = e1->e;
					ed2->s = e1->e;
					ed2->e = e2->e;
				}
				else {	//    OPPOSITE
					ed->s = e1->s;
					ed2->s = e2->s;
					ed2->e = e1->s;
				}
			}
			if ( dirc == FACE || dirc == REVERSE )
				ed->s = getvert ( c2, ed->e, e2->s );
			else
				ed->e = getvert ( c2, ed->s, e2->e );
			if ( dirc == INTURN || dirc == FACE ) {
				deledgefrommed ( m, e2, getvert ( c2, e1->e, e2->s ),
								 getvert ( c2, e1->e, e2->e ) );
				addpoint ( c2, e1->e );
			}
			else {
				deledgefrommed ( m, e2, getvert ( c2, e1->s, e2->s ),
								 getvert ( c2, e1->s, e2->e ) );
				addpoint ( c2, e1->s );
			}
			setlinescope ( ed );
			addedgetomed ( m, ed );
			break;
		case 10:
			break;
	}			//swtich	
	if ( ed2 != NULL ) {	//Has a new FORCE edge
		if ( addedgetomed ( m, ed2 ) != NULL )
			addedgetocond ( m, cond + condno, ed2 );
		return TRUE;	//medium has a FORCE edge of this conductor
	}
	else
		return FALSE;
}

Edge *addedgetomed ( Medium *m, Edge *ed )
{
	Edge **medge = NULL;
	int i = -1;

	//It's neccessary to make sure if it's really the edge searched
	while ( i != -2 ) {			//Some more edges in m haven't checked
		i = searchedge ( m, i + 1, ed->s, ed->e );
		if ( i != -2 )
		  //if (m->edge[i]->s==ed->s && m->edge[i]->e==ed->e)  //maybe the same one
		  //last condition is no use.
		  //if value of two verts are same,there addresses are same too
		  //So I use edgetype and electype now.		txb98.8.2
			if ( m->edge[i]->edgetype == ed->edgetype )
				if ( m->edge[i]->electype == ed->electype )
				{
					//compare two edges' address is wrong,corrected 98.5.7
					return ( NULL );
				}
	}

	medge = m->edge;
	ed->s->edgenum++;
	ed->e->edgenum++;
	if ( m->edgenum % _edgeCount == 0 )

	{
		medge =
			( Edge ** ) realloc ( ( char * ) medge,
								  ( m->edgenum + _edgeCount ) * sizeof ( Edge * ) );
		m->edgevalidity =
			( Bool * ) realloc ( ( char * ) m->edgevalidity,
								 ( m->edgenum + _edgeCount ) * sizeof ( Bool ) );
	}
	m->edge = medge;
	m->edge[m->edgenum] = ed;

	m->edgevalidity[m->edgenum] = TRUE;
	m->edgenum++;
	m->validedgenum++;
	return ( ed );
}

void addedgetocond ( Medium *m, Conductor *c, Edge *ed )
{
	Edge **cedge = NULL;

		setlinescope ( ed );
	cedge = c->edge;
	if ( c->edgenum++ == 0 )
		cedge = ( Edge ** ) malloc ( sizeof ( Edge * ) );
	else
		cedge = ( Edge ** ) realloc ( ( char * ) cedge, c->edgenum * sizeof ( Edge * ) );
	c->edge = cedge;
	c->edge[c->edgenum - 1] = ed;
	ed->medium = m->mediumno;
	ed->condno = condno;
	ed->portno = c->portno;
	if ( ed->maxx > c->maxx )
		c->maxx = ed->maxx;
	if ( ed->maxy > c->maxy )
		c->maxy = ed->maxy;
	if ( ed->minx < c->minx )
		c->minx = ed->minx;
	if ( ed->miny < c->miny )
		c->miny = ed->miny;
	//txb98.4.9 responding to vs and ve,as and ae must be changed too
}

void shapesindiffmed ( Shell *s1, Shell *s2, ShellRelation sr )
{
	ShapeEdge *c1 = NULL, *c2 = NULL;
	ShapeEdge *se1 = NULL, *se2 = NULL;
	Edge *e1 = NULL, *e2 = NULL;

	se1 = s1->edge;
	se2 = s2->edge;
	for ( c1 = se1; c1 != NULL; c1 = c1->next ) {
		e1 = c1->ed;
		for ( c2 = se2; c2 != NULL; c2 = c2->next ) {
			e2 = c2->ed;
			switch ( edgerelation ( e1, e2 ) ) {
				case DISCONNECT:
					break;
				case CONNECT:
					break;
				case SAMESTART:
				case SAMEEND:
				case REVERSECONNECT:
					break;
				case SHARELINE:
					if ( e1->electype == NATURAL && e2->electype == NATURAL )   //txb98.3.22
						sharelineindiffmed ( s1, s2, c1, c2, e1, e2 );
					break;
				case CROSS:
					printf ( "Edges in different mediums cannot be crossed\n" );
					break;
				default:
					break;
			}
		}
	}
}

void
sharelineindiffmed ( Shell *s1, Shell *s2, ShapeEdge *c1, ShapeEdge *c2,
					 Edge *e1, Edge *e2 )
{// reverse edge in this function is added by txb in 98.4.12
// point to the other side of BORDER
  //already meet : 
  //             0-0 0-1
  //             1-3
  //             2-3
  //             3-2 3-3
  //             4-3
  //             5-2 5-3
  //             6-3
  //             7-3
  //             8-2
  //             9-3
  //             10-0 10-1

	short type;
	ShareLineDircRela dirc;
	Edge *ed = NULL, *edd = NULL;	//edd is the reverse edge of ed, two sides of BORDER
									//ed has the same direction as e1, edd as e2
									//except s and e, other fields are all same
	ShapeEdge *se = NULL, *see = NULL;
	ShapeEdge *se1 = s1->edge;
	ShapeEdge *se2 = s2->edge;

	type = sharelinetype ( e1, e2 );
	dirc = sharelinedircrela ( e1, e2 );

	if ( ( dirc == INTURN || dirc == REVERSE ) && type != 0 && type != 10 ) {
		printf ( "Errors in sharelineindiffmed,type=%d\n", type );
		printanedge ( e1 );
		printanedge ( e2 );
		if ( dirc == INTURN )
			printf ( "INTURN\n" );
		else
			printf ( "REVERSE\n" );
		return;
	}
	switch ( type ) {
		case 0:
			break;
		case 1:
			edd = createnewedge();
			edd->electype = BORDER;
			edd->medium = e1->medium;
			edd->reversemed = e2->medium;
			see = createshapeedge();
			see->ed = edd;

			ed = createnewedge();
			ed->electype = BORDER;
			ed->medium = e1->medium;
			ed->reversemed = e2->medium;
			se = createshapeedge();
			se->ed = ed;
			switch ( dirc ) {
				case OPPOSITE:
					ed->s = e2->e;
					ed->e = e1->e;
					edd->s = e1->e;
					edd->e = e2->e;
					e1->e = ed->s;
					e2->e = ed->e;
					se1 = addedge ( se1, c1, se, 0 );
					se2 = addedge ( se2, c2, see, 0 );
					//Insert ed after e1 and e2
					break;
				case FACE:
					ed->s = e1->s;
					ed->e = e2->s;
					edd->s = e2->s;
					edd->e = e1->s;
					e1->s = ed->e;
					e2->s = ed->s;
					se1 = addedge ( se1, c1, se, 1 );
					se2 = addedge ( se2, c2, see, 1 );
					//Insert ed before e2 and e1
					break;
				default:
					break;
			}
			ed->s->edgenum++;
			ed->e->edgenum++;
			setlinescope ( ed );
			setlinescope ( edd );
			setlinescope ( e1 );
			setlinescope ( e2 );
			if ( e1->elenum > e2->elenum )
				edd->elenum = ( e1->elenum - 1 ) / 2 + 1;
			else
				edd->elenum = ( e2->elenum - 1 ) / 2 + 1;
			ed->elenum = edd->elenum;
			e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
			e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
			break;
		case 2:
			edd = createnewedge();
			edd->electype = BORDER;
			edd->medium = e1->medium;
			edd->reversemed = e2->medium;
			see = createshapeedge();
			see->ed = edd;
			edd->s = e1->e;
			edd->e = e1->s;

			e1->electype = BORDER;
			e1->reversemed = e2->medium;
			se = createshapeedge();
			se->ed = e1;
			switch ( dirc ) {
				case FACE:
					e2->s = e1->s;
					se2 = addedge ( se2, c2, see, 1 );
					e1->e->edgenum--;
					e1->s->edgenum++;
					break;
				case OPPOSITE:
					e2->e = e1->e;
					se2 = addedge ( se2, c2, see, 0 );
					e1->s->edgenum--;
					e2->e->edgenum++;
					break;
				default:
					break;
			}
			setlinescope ( e2 );
			setlinescope ( edd );
			edd->elenum = e1->elenum;
			e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
			break;
		case 3:
			e1->electype = BORDER;
			e1->reversemed = e2->medium;

			ed = createnewedge();
			edd = createnewedge();
			se = createshapeedge();
			see = createshapeedge();
			se->ed = ed;
			see->ed = edd;
			filledgefield ( edd, e1 );
			filledgefield ( ed, e2 );
			ed->s = e1->s;
			edd->s = e1->e;
			edd->e = e1->s;
			e2->e = e1->e;
			e1->s->edgenum++;
			e1->e->edgenum++;
			setlinescope ( ed );
			setlinescope ( edd );
			setlinescope ( e2 );
			se2 = addedge ( se2, c2, see, 0 );
			se2 = addedge ( se2, see, se, 0 );
			ed->elenum = ( e2->elenum - 1 ) / 2 + 1;
			e2->elenum = ed->elenum;
			edd->elenum = e1->elenum;
			break;
		case 4:
			e2->electype = BORDER;
			e2->reversemed = e2->medium;
			e2->medium = e1->medium;
			se = createshapeedge();
			ed = createnewedge();
			se->ed = ed;
			filledgefield ( ed, e2 );
			ed->s = e2->e;
			ed->e = e2->s;
			switch ( dirc ) {
				case FACE:
					e1->s = e2->s;
					se1 = addedge ( se1, c1, se, 1 );
					e2->e->edgenum--;
					e2->s->edgenum++;
					break;
				case OPPOSITE:
					e1->e = e2->e;
					se1 = addedge ( se1, c1, se, 0 );
					e2->s->edgenum--;
					e2->e->edgenum++;
					break;
				default:
					break;
			}
			setlinescope ( e1 );
			setlinescope ( ed );
			ed->elenum = e2->elenum;
			e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
			break;
		case 5:
			e1->electype = BORDER;
			e1->reversemed = e2->medium;
			filledgefield ( e2, e1 );
			e2->s = e1->e;
			e2->e = e1->s;
			e1->e->edgenum--;
			e1->s->edgenum--;
			if ( e1->elenum > e2->elenum )
				e2->elenum = e1->elenum;
			else
				e1->elenum = e2->elenum;
			break;
		case 6:
			e1->electype = BORDER;
			e1->reversemed = e2->medium;
			edd = createnewedge();
			see = createshapeedge();
			see->ed = edd;
			filledgefield ( edd, e1 );
			edd->s = e1->e;
			edd->e = e1->s;
			switch ( dirc ) {
				case FACE:
					e2->e = e1->e;
					se2 = addedge ( se2, c2, see, 0 );
					e1->s->edgenum--;
					e1->e->edgenum++;
					break;
				case OPPOSITE:
					e2->s = e1->s;
					se2 = addedge ( se2, c2, see, 1 );
					e1->s->edgenum++;
					e1->e->edgenum--;
					break;
				default:
					break;
			}
			setlinescope ( e2 );
			setlinescope ( edd );
			edd->elenum = e1->elenum;
			e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
			break;
		case 7:
			e2->electype = BORDER;
			e2->reversemed = e2->medium;
			e2->medium = e1->medium;
			ed = createnewedge();
			se = createshapeedge();
			se->ed = ed;
			filledgefield ( ed, e2 );
			ed->s = e2->e;
			ed->e = e2->s;
			edd = createnewedge();
			see = createshapeedge();
			see->ed = edd;
			filledgefield ( edd, e1 );
			edd->s = e2->s;
			e1->e = e2->e;
			e2->s->edgenum++;
			e2->e->edgenum++;
			setlinescope ( ed );
			setlinescope ( edd );
			setlinescope ( e1 );
			se1 = addedge ( se1, c1, se, 0 );
			se1 = addedge ( se1, se, see, 0 );
			edd->elenum = ( e1->elenum - 1 ) / 2 + 1;
			e1->elenum = edd->elenum;
			ed->elenum = e2->elenum;
			break;
		case 8:
			e2->electype = BORDER;
			e2->reversemed = e2->medium;
			e2->medium = e1->medium;
			ed = createnewedge();
			se = createshapeedge();
			se->ed = ed;
			filledgefield ( ed, e2 );
			ed->s = e2->e;
			ed->e = e2->s;
			switch ( dirc ) {
				case FACE:
					e1->e = e2->e;
					e2->s->edgenum--;
					e2->e->edgenum++;
					se1 = addedge ( se1, c1, se, 0 );
					break;
				case OPPOSITE:
					e1->s = e2->s;
					e2->e->edgenum--;
					e2->s->edgenum++;
					se1 = addedge ( se1, c1, se, 1 );
					break;
				default:
					break;
			}
			setlinescope ( ed );
			setlinescope ( e1 );
			ed->elenum = e2->elenum;
			e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
			break;
		case 9:
			ed = createnewedge();
			ed->electype = BORDER;
			ed->medium = e1->medium;
			ed->reversemed = e2->medium;
			se = createshapeedge();
			se->ed = ed;

			edd = createnewedge();
			edd->electype = BORDER;
			edd->medium = e1->medium;
			edd->reversemed = e2->medium;
			see = createshapeedge();
			see->ed = edd;
			switch ( dirc ) {
				case FACE:
					ed->s = e2->e;
					ed->e = e1->e;
					e1->e = ed->s;
					e2->e = ed->e;
					edd->s = ed->e;
					edd->e = ed->s;
					se1 = addedge ( se1, c1, se, 0 );
					se2 = addedge ( se2, c2, see, 0 );
					break;
				case OPPOSITE:
					ed->s = e1->s;
					ed->e = e2->s;
					e1->s = ed->e;
					e2->s = ed->s;
					edd->s = ed->e;
					edd->e = ed->s;
					se1 = addedge ( se1, c1, se, 1 );
					se2 = addedge ( se2, c2, see, 1 );
					break;
				default:
					break;
			}
			ed->s->edgenum++;
			ed->e->edgenum++;
			setlinescope ( e1 );
			setlinescope ( e2 );
			setlinescope ( ed );
			setlinescope ( edd );
			if ( e1->elenum > e2->elenum )
				edd->elenum = ( e1->elenum - 1 ) / 2 + 1;
			else
				edd->elenum = ( e2->elenum - 1 ) / 2 + 1;
			ed->elenum = edd->elenum;
			e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
			e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
			break;
		case 10:
			break;
	}
	s1->edge = se1;
	s2->edge = se2;
}

//To deal with single line, it's hard to decide which part should be keep
//when tmp==NULL,the handle is just reversed
//other cases,should discuss by two kinds,
void crossinsameobj ( ShapeEdge *c1, ShapeEdge *c2, Edge *e1, Edge *e2 )
{
	Vert *tmp = NULL;

	tmp = crosspoint ( e1, e2 );
//       printf("Here\n");
//       printpoint(tmp);

	if ( tmp == NULL )
		printf ( "these two edges have no cross point\n" );
	else if ( tmp == e2->e ) {
	}
	else if ( tmp == e2->s ) {
	}
	else if ( tmp == e1->e ) {
	}
	else if ( tmp == e1->s ) {
	}
	else {
		//Is a real cross
		if ( crossdircrela ( e1, e2 ) == ANTICLOCKWISE ) {
			addpoint ( c1, tmp );
			addpoint ( c1, e1->e );
			addpoint ( c2, e2->s );
			addpoint ( c2, tmp );
		}
		else {		//CLOCKWISE
			addpoint ( c1, e1->s );
			addpoint ( c1, tmp );
			addpoint ( c2, tmp );
			addpoint ( c2, e2->e );
		}
	}
}

Flag sharelineinsameobj ( Shell *s1, Shell *s2, ShapeEdge *c1, ShapeEdge *c2, Edge *e1, Edge *e2 )
{
	//correct edgenum in case 5 in 98.5.7
	short type;
	ShareLineDircRela dirc;
	Vert *tmp = NULL;
	Flag f1;
	Edge *ed = NULL;
	ShapeEdge *se = NULL;
	ShapeEdge *se1 = s1->edge, *se2 = s2->edge;
  //already meet 
  //            2-0 2-3
  //            3-2
  //            5-3
  //            6-0
  //            7-2

	type = sharelinetype ( e1, e2 );
	dirc = sharelinedircrela ( e1, e2 );
  /*
     printf("\n");
     printanedge(e1);
     printanedge(e2);
     printf("type=%d,dirc=%d\n",type,dirc);
   */
	f1 = 1;
	switch ( type ) {
		case 0:
			break;
		case 1:
			switch ( dirc ) {
				case INTURN:
					e1->s->edgenum--;
					e1->s = e2->s;
					e2->s->edgenum++;
					setlinescope ( e1 );
					e1->elenum += e2->elenum;
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy, 3/4/2013
					break;
				case OPPOSITE:
					tmp = e2->e;
					e2->e = e1->e;
					e1->e = tmp;
					setlinescope ( e1 );
					setlinescope ( e2 );
					e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
					e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
					break;
				case FACE:
					tmp = e2->s;
					e2->s = e1->s;
					e1->s = tmp;
					setlinescope ( e1 );
					setlinescope ( e2 );
					e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
					e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
					break;
				case REVERSE:
					e1->e->edgenum--;
					e1->e = e2->e;
					e2->e->edgenum++;
					e1->elenum += e2->elenum;
					setlinescope ( e1 );
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy, 3/4/2013
					break;
			}	//End of 1
			break;
		case 2:
			switch ( dirc ) {
				case INTURN:
					se1 = remove ( se1, c1 );
					free ( c1 );  //added by ysy, 3/4/2013
					f1 = 0;
					break;
				case OPPOSITE:
					e2->e->edgenum--;
					e2->e = e1->e;
					e1->e->edgenum++;
					setlinescope ( e2 );
					se1 = remove ( se1, c1 );
					free ( c1 );  //added by ysy, 3/4/2013
					f1 = 0;
					break;
				case FACE:
					e2->s->edgenum--;
					e2->s = e1->s;
					e1->s->edgenum++;
					setlinescope ( e2 );
					se1 = remove ( se1, c1 );
					free ( c1 );  //added by ysy, 3/4/2013
					f1 = 0;
					break;
				case REVERSE:
					se1 = remove ( se1, c1 );
					free ( c1 );  //added by ysy,3/4/2013
					f1 = 0;
					break;
			}
			break;
		case 3:
			switch ( dirc ) {
				case REVERSE:
				case INTURN:
					se1 = remove ( se1, c1 );
					free ( c1 );  //added by ysy,3/4/2013
					f1 = 0;
					break;
				case OPPOSITE:
				case FACE:
					ed = createnewedge();
					filledgefield ( ed, e2 );
					ed->s = e1->s;
					ed->e = e2->e;
					ed->electype = e1->electype;
					e1->s->edgenum++;
					e1->e->edgenum++;
					setlinescope ( ed );
					ed->elenum = ( e2->elenum - 1 ) / 2 + 1;
					e2->e = e1->e;
					e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
					setlinescope ( e2 );
					se1 = remove ( se1, c1 );
					free ( c1 );  //added by ysy,3/4/2013
					f1 = 0;
					se = createshapeedge();
					se->ed = ed;
					se->next = c2->next;
					c2->next = se;
					//Keep edgenum of all four verts
					break;
			}
			break;
		case 4:
			switch ( dirc ) {
				case INTURN:
				case REVERSE:
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy,3/4/2013
					break;
				case FACE:
					e1->s->edgenum--;
					e1->s = e2->s;
					e2->s->edgenum++;
					setlinescope ( e1 );
					e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy, 3/4/2013
					break;
				case OPPOSITE:
					e1->e->edgenum--;
					e1->e = e2->e;
					e2->e->edgenum++;
					setlinescope ( e1 );
					e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy,3/4/2013
					break;
			}
			break;
		case 5:
			switch ( dirc ) {
				case INTURN:
				case REVERSE:
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy,3/4/2013
					break;
				case FACE:
				case OPPOSITE:
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy,3/4/2013
					se1 = remove ( se1, c1 );
					free ( c1 );  //added by ysy,3/4/2013
					f1 = 0;
					break;
			}
			break;
		case 6:
			switch ( dirc ) {
				case INTURN:
				case REVERSE:
					se1 = remove ( se1, c1 );
					free ( c1 );  //added by ysy,3/4/2013
					f1 = 0;
					break;
				case FACE:
					e2->e->edgenum--;
					e2->e = e1->e;
					e1->e->edgenum++;
					setlinescope ( e2 );
					e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
					se1 = remove ( se1, c1 );
					free ( c1 );  //added by ysy,3/4/2013
					f1 = 0;
					break;
				case OPPOSITE:
					e2->s->edgenum--;
					e2->s = e1->s;
					e1->s->edgenum++;
					setlinescope ( e2 );
					e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
					se1 = remove ( se1, c1 );
					free ( c1 );  //added by ysy,3/4/2013
					f1 = 0;
					break;
			}
			break;
		case 7:
			switch ( dirc ) {
				case INTURN:
				case REVERSE:
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy,3/4/2013
					break;
				case FACE:
				case OPPOSITE:
					ed = createnewedge();
					filledgefield ( ed, e1 );
					ed->s = e2->s;
					ed->e = e1->e;
					e2->s->edgenum++;
					e2->e->edgenum++;
					setlinescope ( ed );
					se = createshapeedge();
					se->ed = ed;
					e1->e = e2->e;
					setlinescope ( e1 );
					e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
					ed->elenum = e1->elenum;
					se->next = c1->next;
					c1->next = se;
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy,3/4/2013
					break;
			}
			break;
		case 8:
			switch ( dirc ) {
				case INTURN:
				case REVERSE:
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy,3/4/2013
					break;
				case FACE:
					e1->e->edgenum--;
					e1->e = e2->e;
					e2->e->edgenum++;
					setlinescope ( e1 );
					e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy,3/4/2013
					break;
				case OPPOSITE:
					e1->s->edgenum--;
					e1->s = e2->s;
					e2->s->edgenum++;
					setlinescope ( e1 );
					e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
					se2 = remove ( se2, c2 );
					free ( c2 );  //added by ysy,3/4/2013
					break;
			}
			break;
		case 9:
			switch ( dirc ) {
				case INTURN:
					e1->e->edgenum--;
					e1->e = e2->e;
					e2->e->edgenum++;
					setlinescope ( e1 );
					e1->elenum += e2->elenum;
					se2 = remove ( se2, c2 );
					free ( c2 );//added by ysy,3/4/2013

					break;
				case REVERSE:
					e1->s->edgenum--;
					e1->s = e2->s;
					e2->s->edgenum++;
					e1->elenum += e2->elenum;
					setlinescope ( e1 );
					se2 = remove ( se2, c2 );
					free ( c2 );//added by ysy,3/4/2013

					break;
				case FACE:
					tmp = e1->e;
					e1->e = e2->e;
					setlinescope ( e1 );
					e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
					e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
					e2->e = tmp;
					setlinescope ( e2 );
					break;
				case OPPOSITE:
					tmp = e2->s;
					e2->s = e1->s;
					setlinescope ( e2 );
					e1->s = tmp;
					setlinescope ( e1 );
					e1->elenum = ( e1->elenum - 1 ) / 2 + 1;
					e2->elenum = ( e2->elenum - 1 ) / 2 + 1;
					break;
			}
			break;
		case 10:
			break;
	}
	s1->edge = se1;
	s2->edge = se2;
	return ( f1 );
}

EdgeRelation edgerelation ( Edge *e1, Edge *e2 )
{

	//Do not classify edges as LINE or not
	//discuss this at  "crosspoint" later
	if ( Less ( e2->maxx, e1->minx ) || Less ( e2->maxy, e1->miny )
			|| Less ( e1->maxx, e2->minx ) || Less ( e1->maxy, e2->miny ) )
		return ( DISCONNECT );

		if ( isshareline ( e1, e2 ) == TRUE )
			return ( SHARELINE );

	// not merge
	if ( ptEqual ( e1->s->x, e2->e->x ) && ptEqual ( e1->s->y, e2->e->y ) )
		return ( REVERSECONNECT );
	else if ( ptEqual ( e1->e->x, e2->s->x ) && ptEqual ( e1->e->y, e2->s->y ) )
		return ( CONNECT );
	else if ( ptEqual ( e1->s->x, e2->s->x ) && ptEqual ( e1->s->y, e2->s->y ) )
		return ( SAMESTART );
	else if ( ptEqual ( e1->e->x, e2->e->x ) && ptEqual ( e1->e->y, e2->e->y ) )
		return ( SAMEEND );
	else if ( crosspoint ( e1, e2 ) != NULL )
		return ( CROSS );
	else
		return ( DISCONNECT );
}

Vert *crosspoint ( Edge *e1, Edge *e2 )
{
	double d, l, m = -1.0, x2, x1, y2, y1, u2, u1, v2, v1;
	Vert *ve = NULL;
	Edge *tmp = NULL;

	x2 = e1->e->x;
	x1 = e1->s->x;
	y2 = e1->e->y;
	y1 = e1->s->y;
	u2 = e2->e->x;
	u1 = e2->s->x;
	v2 = e2->e->y;
	v1 = e2->s->y;
	d = ( x2 - x1 ) * ( v2 - v1 ) - ( u2 - u1 ) * ( y2 - y1 );
	if ( !Equal ( d, 0.0 ) ) {		//Two line has cross point
		l = ( u1 - x1 ) * ( v2 - v1 ) - ( u2 - u1 ) * ( v1 - y1 );
		// 0<=l<=d     ||   d<=l<=0
		if ( ( !Greater ( 0.0, l ) && !Greater ( l, d ) )
				|| ( !Greater ( d, l ) && !Greater ( l, 0.0 ) ) )
			//cross point belongs to e1
		{
			m = ( y2 - y1 ) * ( u1 - x1 ) - ( x2 - x1 ) * ( v1 - y1 );
			// 0<=m<=d  ||  d<=m<=0
			if ( ( !Greater ( 0.0, m ) && !Greater ( m, d ) )
					|| ( !Greater ( d, m ) && !Greater ( m, 0.0 ) ) )
				//cross point belongs to e2
			{
				if ( Equal ( l, 0.0 ) )
					return ( e1->s );
				else if ( Equal ( l, d ) )
					return ( e1->e );
				else if ( Equal ( m, 0.0 ) )
					return ( e2->s );
				else if ( Equal ( m, d ) )
					return ( e2->e );
				else {			//cross point does not exist before
					l /= d;
					double tmpx, tmpy;
					tmpx = x1 + ( x2 - x1 ) * l;
					tmpy = y1 + ( y2 - y1 ) * l;
					ve = searchvert ( tmpx, tmpy );
					if ( ve == NULL ) {
						ve = createnewvert();
						ve->x = tmpx;
						ve->y = tmpy;
						ve->edgenum = 0;
						return ( ve );
					}
					else {
						return ( ve );
					}
				}
			}
		}
	}
	return ( NULL );
}

int sharelinetype ( Edge *e1, Edge *e2 )
{
	Vert **v = NULL, *tmp = NULL;
	int i, j;

	//Strange erroe here. When there realloc in createnewedge,
	//after "v1s->x=e1->minx", vertexes of edge[0] changed to 0x0
	//Reason unknown, so enlarge initial value when malloc "edge"

	v = ( Vert ** ) malloc ( 4 * sizeof ( Vert * ) );
	v[0] = e1->s;
	v[1] = e1->e;
	v[2] = e2->s;
	v[3] = e2->e;
	for ( i = 0; i < 4; i++ )
		for ( j = i + 1; j < 4; j++ )
			if ( !pointLess ( v[i], v[j] ) ) {
				tmp = v[i];
				v[i] = v[j];
				v[j] = tmp;
			}
	//relation  : 0 --        ____----
	//            1           ____==--
	//            2           ____====
	//            3           ____====___
	//            4               ==--
	//            5               ====
	//            6               ====__
	//            7               -==-
	//            8               -===
	//            9               -===____
	//           10               ----_____
	if ( ptEqual ( v[1]->x, v[2]->x ) && ptEqual ( v[1]->y, v[2]->y ) ) {
		if ( v[3] == e1->s || v[3] == e1->e ) {
			free ( v );
			return ( 0 );
		}
		else {
			free ( v );
			return ( 10 );
		}
	}
	if ( pointLess ( v[0], v[1] ) && pointLess ( v[1], v[2] ) && pointLess ( v[2], v[3] ) ) {
		if ( ( v[2] == e2->s || v[2] == e2->e ) && ( v[1] == e1->s || v[1] == e1->e ) ) {
			free ( v );
			return ( 1 );
		}
		else if ( ( v[1] == e1->s || v[1] == e1->e ) && ( v[2] == e1->s || v[2] == e1->e ) ) {
			free ( v );
			return ( 3 );
		}
		else if ( ( v[1] == e2->s || v[1] == e2->e ) && ( v[2] == e2->s || v[2] == e2->e ) ) {
			free ( v );
			return ( 7 );
		}
		else if ( ( v[1] == e2->s || v[1] == e2->e ) && ( v[2] == e1->s || v[2] == e1->e ) ) {
			free ( v );
			return ( 9 );
		}
	}
	if ( ptEqual ( v[2]->x, v[3]->x ) && ptEqual ( v[2]->y, v[3]->y ) ) {
		if ( ptEqual ( v[0]->x, v[1]->x ) && ptEqual ( v[0]->y, v[1]->y ) ) {
			free ( v );
			return ( 5 );
		}
		else if ( ( v[0] == e2->s || v[0] == e2->e ) && ( v[1] == e1->s || v[1] == e1->e ) ) {
			free ( v );
			return ( 2 );
		}
		else if ( ( v[0] == e1->s || v[0] == e1->e ) && ( v[1] == e2->s || v[1] == e2->e ) ) {
			free ( v );
			return ( 8 );
		}
	}
	if ( ptEqual ( v[0]->x, v[1]->x ) && ptEqual ( v[0]->y, v[1]->y ) ) {
		if ( ( v[2] == e2->s || v[2] == e2->e ) && ( v[3] == e1->s || v[3] == e1->e ) ) {
			free ( v );
			return ( 4 );
		}
		else if ( ( v[2] == e1->s || v[2] == e1->e ) && ( v[3] == e2->s || v[3] == e2->e ) ) {
			free ( v );
			return ( 6 );
		}
		return ( -1 );
	}
	assert ( 0 );
	free ( v );
	return -1;
}

ShareLineDircRela sharelinedircrela ( Edge *e1, Edge *e2 )
{
	if ( linedirection ( e1 ) == POSITIVE )
		if ( linedirection ( e2 ) == POSITIVE )
			return ( INTURN );
		else
			return ( FACE );
	else if ( linedirection ( e2 ) == POSITIVE )
		return ( OPPOSITE );
	else
		return ( REVERSE );
}

CrossDircRela crossdircrela ( Edge *e1, Edge *e2 )
{
	double a1, a2, b1, b2;

	a1 = e1->e->x - e1->s->x;
	b1 = e1->e->y - e1->s->y;
	a2 = e2->e->x - e2->s->x;
	b2 = e2->e->y - e2->s->y;
	if ( Greater ( a1 * b2 - a2 * b1, 0.0 ) )	//angle from e1 to e2 is positive
		return ( ANTICLOCKWISE );
	else
		return ( CLOCKWISE );
}

LineDirection linedirection ( Edge *ed )
{
	if ( pointLess ( ed->s, ed->e ) )
		return ( POSITIVE );
	else
		return ( NEGATIVE );
}

Flag pointLess ( Vert *s, Vert *e )
{
	if ( ptLess ( s->x, e->x ) )
		return ( 1 );
	else if ( ptEqual ( s->x, e->x ) && ptLess ( s->y, e->y ) )
		return ( 1 );
	else
		return ( 0 );
}

Bool isshareline ( Edge *e1, Edge *e2 )
{
	if ( Equal ( e1->A, e2->A ) && Equal ( e1->B, e2->B ) && Equal ( e1->C, e2->C ) )
		return ( TRUE );
	else if ( Equal ( e1->A, -e2->A ) && Equal ( e1->B, -e2->B ) && Equal ( e1->C, -e2->C ) )
		return ( TRUE );
	else
		return ( FALSE );
}

void setequationofline ( Edge *ed )
{
	double tmp;

		ed->A = ed->e->y - ed->s->y;
		ed->B = ed->s->x - ed->e->x;
		ed->C = -ed->A * ed->s->x - ed->B * ed->s->y;
		tmp = sqrt ( ed->A * ed->A + ed->B * ed->B );
		ed->A /= tmp;
		ed->B /= tmp;	//A^2+B^2=1
		ed->C /= tmp;
}

ShapeEdge *remove ( ShapeEdge *s, ShapeEdge *c )
{
	ShapeEdge *tmp = NULL;

	if ( c == NULL ) ;
	//printf("Cannot remove an empty ShapeEdge\n");
	else if ( c->next == NULL ) {	//Tail point
		if ( s == c ) {		//Only one point
			s = NULL;
		}
		else {
			c->ed->s->edgenum--;
			c->ed->e->edgenum--;
			for ( tmp = s; tmp->next != c; tmp = tmp->next ) ;	//Found the edge before c->ed
			c = tmp;
			c->next = NULL;
		}
	}
	else if ( s == c ) {	//head point
		c->ed->s->edgenum--;
		c->ed->e->edgenum--;
		s = s->next;
		tmp = c;
	}
	else {
		//no head,no tail
		c->ed->s->edgenum--;
		c->ed->e->edgenum--;
		for ( tmp = s; tmp->next != c; tmp = tmp->next ) ;
		c = tmp;
		tmp = c->next;
		c->next = tmp->next;
	}
	return s;
}

ShapeEdge *addedge ( ShapeEdge *s, ShapeEdge *a, ShapeEdge *b, Flag f )
{
	ShapeEdge *tmp = NULL;

	if ( s == NULL || a == NULL || b == NULL ) ;
	//printf("NULL edge in addedge\n");
	if ( f == 0 ) {				// Add b after a
		b->next = a->next;
		a->next = b;
	}
	else	// f==1  insert b before a
		if ( s == a ) {		//a is the head
			s = b;
			b->next = a;
		}
		else {
			for ( tmp = s; tmp->next != a; tmp = tmp->next ) ;	//found the edge before a->ed
			tmp->next = b;
			b->next = a;
		}
	return s;
}

void printshapeedge ( ShapeEdge *se )
{
	ShapeEdge *c = NULL;

	if ( se == NULL ) ;
	//printf("This shell is empty\n");
	for ( c = se; c != NULL; c = c->next ) {
		printanedge ( c->ed );
	}
}

void printanedge ( Edge *ed )
{
	if ( ed != NULL ) {
		if ( ed->electype == FORCE )
			printf ( "FORCE  " );
		else if ( ed->electype == BORDER )
			printf ( "BORDER " );
		else
			printf ( "NATURAL" );
		printf ( "        " );
		printf ( "(%6.2f,%6.2f) (%6.2f,%6.2f) %d %d  %p\n", ed->s->x, ed->s->y,
				 ed->e->x, ed->e->y, ed->s->edgenum, ed->e->edgenum, ed );

		printf
		( "medium:%2d %2d cond:%2d %2d   elenum:%d vtype:%2d %2d vno:%2d %2d\n",
		  ed->medium, ed->reversemed, ed->condno, ed->portno, ed->elenum,
		  ed->stype, ed->etype, ed->sno, ed->eno );
	}
	else
		printf ( "Edge is NULL\n" );
}

void printpoint ( Vert *v )
{
	printf ( "(%6.2f,%6.2f) %d\n", v->x, v->y, v->edgenum );
}

int removeresidualedge ( Shell *s )
{
	int flag = 0;
	ShapeEdge *se = NULL, *c = NULL;

	se = s->edge;
	for ( c = se; c != NULL; c = c->next )
			if ( ( c->ed->s->edgenum < 2 ) || ( c->ed->e->edgenum < 2 ) )
			{
				//corrected in 98.5.6
				//We only consider Feng1Bi4 polygon,not single lines
				//A special case is substrate
				//    if((c->ed->s->edgenum>=3) && (c->ed->e->edgenum>=3))
//    if((c->ed->s->edgenum>=3) && (c->ed->e->edgenum>=3) || (c->ed->s->edgenum<2) || (c->ed->e->edgenum<2))
	
				c->ed->s->edgenum--;
				c->ed->e->edgenum--;
				se = remove ( se, c );
				flag = 1;
				//printf("remove se,c\n");
			}
	s->edge = se;
	return flag;
}

int searchedge ( Medium *m, int i0, Vert *s, Vert *e )
{
	int i;
	Edge *ed = NULL;

	for ( i = i0; i < m->edgenum; i++ ) {
		ed = m->edge[i];
		if ( m->edgevalidity[i] == TRUE )
			if ( ptEqual ( ed->s->x, s->x ) )
				if ( ptEqual ( ed->s->y, s->y ) )
					if ( ptEqual ( ed->e->x, e->x ) )
						if ( ptEqual ( ed->e->y, e->y ) )
							return ( i );
	}
	return -2;
}

//If there are two edges which have the same s and e,
//error will occur at here
//Because now all medium edges are LINE,
//so keep this function as before
Edge *deledgefrommed ( Medium *m, Edge *e2, Vert *s, Vert *e )
{
	Edge *ed = NULL;
	int i = -1;
	while ( i != -2 ) {
		i = searchedge ( m, i + 1, s, e );
		if ( i != -2 ) {
			ed = m->edge[i];
			if ( e2->edgetype == ed->edgetype )
				if ( e2->electype == ed->electype ) {
					m->edgevalidity[i] = FALSE;
					ed->s->edgenum--;
					ed->e->edgenum--;
					m->validedgenum--;
					return ( ed );
				}
		}
	}
	//assert ( 0 );
	return NULL;
}

Vert *getvert ( ShapeEdge *se, Vert *s, Vert *e )
{
	Vert **po = se->po;
	int num = se->pointnum;
	int i;
	Vert *v = NULL;
	double x, y;

	if ( po != NULL ) {		//some points exist
		if ( Less ( s->x, e->x ) ) {	// --->
			x = e->x;
			for ( i = 0; i < num; i++ )
				if ( Less ( po[i]->x, x ) && Less ( s->x, po[i]->x ) ) {
					v = po[i];
					x = v->x;
				}
		}
		else if ( Greater ( s->x, e->x ) ) {	//<---
			x = e->x;
			for ( i = 0; i < num; i++ )
				if ( Greater ( po[i]->x, x ) && Greater ( s->x, po[i]->x ) ) {
					v = po[i];
					x = v->x;
				}
		}
		else {		//Vertical edge   ^
			if ( Less ( s->y, e->y ) ) {	//   1
				y = e->y;
				for ( i = 0; i < num; i++ )
					if ( Less ( po[i]->y, y ) && Less ( s->y, po[i]->y ) ) {
						v = po[i];
						y = v->y;
					}
			}
			else {		//downward        1
				y = e->y;
				for ( i = 0; i < num; i++ )
					if ( Greater ( po[i]->y, y ) && Greater ( s->y, po[i]->y ) ) {
						v = po[i];
						y = v->y;
					}
			}
		}
	}
	if ( v == NULL )
		v = e;
	return ( v );
}

void printmededge()
{
	int i, j;

	for ( i = 0; i < mednum; i++ ) {
      //printf("medium[%d] has %d conductors,%d edges while %d are valid\n",i,med[i].condnum,med[i].edgenum,med[i].validedgenum);
		for ( j = 0; j < med[i].edgenum; j++ )
			if ( med[i].edgevalidity[j] == TRUE ) {
	    		//printf("%d:",j);
				printanedge ( med[i].edge[j] );
			}
	}
}
